/*
 * a12nd.3.c
 * Copyright (C) 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <a1-types.h>
#include <frame.h>
#include <lxcall.h>
#include <nt.h>
#include <track.h>

extern const struct x1f4_nodetype_type _x1f4_a1_nodetype;

int
_x1f4_a1_late_news(void *node)
{
    struct a1_node_type *node_data;
    struct frame_type frame;
    struct x1f4_track_type track;

    node_data = (void *)
        ((char *) node - offsetof(struct a1_node_type, linetext));

    frame.data = node_data->grid_data->v.data;
    frame.pick = node_data->grid_data->v.pick;

    track.line = NULL;
    track.post = NULL;
    track.push = NULL;

    return _libx1f4i0_lxcall_sand_node
	(&frame, &track, (struct x1f4_nodetype_type *) &_x1f4_a1_nodetype,
	 node);
}
