/*
 * af.p.c
 * Copyright (C) 2014, 2017, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <a1n.h>
#include <af-inter.h>
#include <e4.h>
#include <ln.h>
#include <nl.h>

extern int _libx1f4i0_lxmile_late_mile(void *, void *);
extern int _x1f4_a1_late_news(void *);

static const struct x1f4_linetext_type linetext = {
/* *INDENT-OFF* */
    {	"",
	NULL,
	X1f4_E4_VOID,
	NULL,
	0,
	0,
	0
    },
    NULL
/* *INDENT-ON* */
};

int
_x1f4_push_effect(void *subtext, void **copy, void *last,
		  const struct x1f4_nodelink_type *nodelink_data)
{
    int status;

    do {
	unsigned flags;
	void *half;

	flags = ((const struct x1f4_linetext_type *) last)->function.flags;

	if (flags & X1f4_E4_NODE_LINK) {
	    half = (void *) &linetext;

	    status = _x1f4_a1_push_news(subtext, &half, last, nodelink_data);
	    if (status) {
		break;
	    }
	} else {
	    if (flags & X1f4_E4_OVER_LINK) {
		struct x1f4_leadnode_type *leadnode_data;
		struct x1f4_nodetype_type nodetype, *nodetype_data;

		leadnode_data = last;
		leadnode_data--;

		nodetype_data = leadnode_data->link.nodetype_data;

		/*
		 * seriously wrong: replace the nodetype_data, so that the
		 * right -slip- method is picked.
		 */

		nodetype.slip = _x1f4_slip_effect;

		leadnode_data->link.nodetype_data = &nodetype;

		status = nodetype_data->push
		    (nodetype_data->context, copy, last, nodelink_data);

		leadnode_data->link.nodetype_data = nodetype_data;

		if (1) {
		    break;
		}
	    } else {
		half = last;
	    }
	}

	if (1) {
	    struct x1f4_linetext_type *linetext_data;

	    linetext_data = *copy;
	    flags = linetext_data->function.flags;
	    if (flags & X1f4_E4_NODE_LINK) {
		status = _x1f4_a1_late_news(linetext_data);
	    } else {
		if (flags & X1f4_E4_OVER_LINK) {
		    struct x1f4_leadnode_type *leadnode_data;

		    leadnode_data = (void *) linetext_data;
		    leadnode_data--;

		    status = _libx1f4i0_lxmile_late_mile
			(leadnode_data->link.nodetype_data->context,
			 linetext_data);
		} else {
		    status = _x1f4_slip_effect(subtext, copy);
		}
	    }
	}

	if (1) {
	    /*
	     * at the very least, _slip_effect attempted to destroy the object
	     */
	    *copy = half;
	}
    } while (0);

    return status;
}
