/*
 * af.s.c
 * Copyright (C) 2014, 2016, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <a1n.h>
#include <e4.h>
#include <e4n.h>
#include <ln.h>

int
x1f4_slip_effect(void *subtext, void **data)
{
    int status;
    unsigned flags;

    flags = ((const struct x1f4_linetext_type *) *data)->function.flags;

    if (flags & X1f4_E4_NODE_LINK) {
	status = _x1f4_a1_slip_news(subtext, data);
    } else {
	if (flags & X1f4_E4_NEWS_LINK) {
	    status = _x1f4_e4_slip_news(subtext, data);
	} else {
	    if (flags & X1f4_E4_OVER_LINK) {
		struct x1f4_leadnode_type *leadnode_data;
		struct x1f4_nodetype_type *nodetype_data;

		leadnode_data = *data;
		leadnode_data--;

		nodetype_data = leadnode_data->link.nodetype_data;

		status = nodetype_data->slip(nodetype_data->context, data);
	    } else {
		status = 0;
	    }
	}
    }

    return status;
}
