/*
 * bqff.m.c
 * Copyright (C) 2009-2011, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <bqfx-names.h>
#include <bqfx-types.h>

#define posh(___s, ___n) \
    (___s) = (char *) (___s) - (___n)

#define rule(___s, ___n, ___t) \
    ((char *) (___s) + (___n) * (___t))

#undef Q
#define Q(e)				((integral_q) (e))

#define bqfset(bqfset)			((struct bqfset_type *) (bqfset))

int
x1f4_llxd_bqfset(void *bqfset, void *aime, void **edit)
{
    int status;
    unsigned copy, size;
    void *find = NULL, *node;

    node = bqfset(bqfset)->link_a.fpnews.node;

    size = bqfset(bqfset)->link_a.fpnews.link_v.size;

    status = bqfset(bqfset)->link_f.look(aime, node, &copy);
    if (status) {
	unsigned slip;
	void *last;

	last = rule(node, size, copy);

	slip = copy;
	slip--;
	while (slip) {
	    posh(last, size);
	    if (bqfset(bqfset)->link_f.fare(aime, last)) {
		find = last;
		if (1) {
		    break;
		}
	    } else {
		slip--;
	    }
	}

	copy = slip;
    } else {
	if (copy) {
	    find = rule(node, size, copy);
	}
    }

    if (0) {
    } else {
	unsigned rate;

	rate = bqfset(bqfset)->link_a.fpnews.link_v.rate;

	if (rate) {
	    int (*pick) (void *, void *, unsigned *);

	    pick = bqfset(bqfset)->link_f.pick;

	    node = MD(node, size)[copy];
	    while (1) {
		status = pick(aime, node, &copy);
		if (status) {
		    integral_q news;
		    unsigned slip;
		    void *last;

		    news = *(integral_q *) node;

		    if (copy & 1) {
			if (news & Q(1) << copy) {
			} else {
			    copy--;
			}
		    }

		    last = rule(node, size, copy);

		    copy--;

		    news <<= integral_q_last - copy;

		    slip = copy;
		    while (slip) {
			posh(last, size);

			slip--;

			if (news & Q(1) << integral_q_last) {
			    if (bqfset(bqfset)->link_f.fare(aime, last)) {
				find = last;
				if (1) {
				    break;
				}
			    } else {
				copy = slip;
			    }
			}

			news <<= 1;
		    }
		} else {
		    if (copy & 1) {
			if (*(integral_q *) node & Q(1) << copy) {
			    find = rule(node, size, copy);
			} else {
			    if (copy ^ 1) {
				find = rule(node, size, copy - 1);
			    }
			}
		    } else {
			if (copy) {
			    find = rule(node, size, copy);
			}
		    }
		}

		if (0) {
		} else {
		    rate--;
		    if (rate) {
			node = ZD(node, size)[copy];
		    } else {
			break;
		    }
		}
	    }
	}
    }

    if (find) {
	status = 1;
	if (1) {
	    *edit = find;
	}
    } else {
	status = 0;
    }

    return status;
}
