/*
 * bqfv.x.c
 * Copyright (C) 2009-2012, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <string.h>

#include <bcount.h>
#include <bqfx-defs.h>
#include <bqfx-inter.h>
#include <bqfx-lines.h>
#include <bqfx-names.h>
#include <bqfx-types.h>

#define __HALF_TRANSFER__		1

#define __SINGLE_MERGE__		1

#define __UNROLL_TRANSFER__		0

#define beta(___s, ___n) \
    (___s) = (char *) (___s) - ((___n) << 1)

#define cell(___s, ___n, ___t) \
    ((char *) (___s) - (___n) * (___t))

#define dana(___s, ___n) \
    (___s) = (char *) (___s) + ((___n) << 1)

#define life(___s, ___n) \
    ((char *) (___s) - (___n))

#define posh(___s, ___n) \
    (___s) = (char *) (___s) - (___n)

#define road(___s, ___n) \
    ((char *) (___s) + ((___n) << 1))

#define rule(___s, ___n, ___t) \
    ((char *) (___s) + (___n) * (___t))

#define sans(___s, ___n) \
    ((char *) (___s) + (___n))

#define skip(___s, ___n) \
    (___s) = (char *) (___s) + (___n)

#define trap(___n, ___s)		((___n) + ((___s) << 2))

#define true(e)				1

#undef Q
#define Q(e)				((integral_q) (e))

#define bqfset(bqfset)			((struct bqfset_type *) (bqfset))

int
_libx1f4l2_grip_bqfset(void *bqfset, void *node)
{
    int (*move)(void *, void *, unsigned), status;
    integral_q next;
    unsigned deck, ever, mind, size;
    void *file, *tier;

    mind = *(integral_q *) node;

    size = bqfset(bqfset)->link_a.fpnews.link_v.size;

    move = bqfset(bqfset)->link_f.move;

    status = 0;

    if (1) {
	tier = MD(node, size)[1];
	next = *(integral_q *) tier;
	l2_q_bitcount(ever, next);
    } else {
    }

    file = MD(node, size)[0];

    if (half_integral_q_bits < ever) {
	if (1) {
#if __HALF_TRANSFER__
	    if (1) {
		integral_q text;
		unsigned slip;
		void *fast, *side;

		fast = rule(file, size, 2);

		deck = (integral_q_bits - 4) >> 1;

# if __UNROLL_TRANSFER__
#  error
# else
		if (deck & 1) {
		    side = road(fast, size);
		    move(fast, side, 1);
		    fast = side;
		}
		deck >>= 1;
		for (; deck; deck--) {
		    side = road(fast, size);
		    move(fast, side, 1);
		    fast = road(side, size);
		    move(side, fast, 1);
		}
# endif				/* __UNROLL_TRANSFER__ */

		fast = file;

		ever -= half_integral_q_bits;

		if (ever < 4) {
		    ever = 1;

		    *(integral_q *) fast = Lx55555555;

		    fast = rule(fast, size, integral_q_bits - 2);
		} else {
		    ever &= ~1;

		    *(integral_q *) fast = Lx55555555
			| ~Q(0) << (integral_q_bits - ever + 2);

		    if (ever < 8) {
			ever >>= 1;

			fast = rule(fast, size, integral_q_bits - ever);
		    } else {
			fast = rule(fast, size, integral_q_bits - ever + 3);

			side = sans(fast, size);

			ever >>= 1;

			deck = ever - 3;
			for (; deck; deck--) {
			    move(fast, side, 1);
			    dana(side, size);
			    skip(fast, size);
			}
		    }
		}

		move(fast, rule(node, size, 1), 1);

		skip(fast, size);

		ever--;

		side = tier;

		text = *(integral_q *) tier;

		while (ever & ~1) {
		    if (text & Q(2)) {
			skip(side, size);
			move(fast, side, 2);
			dana(fast, size);
			skip(side, size);

			ever -= 2;
		    } else {
			ever--;

			dana(side, size);
			move(fast, side, 1);
			skip(fast, size);
		    }

		    text >>= 2;
		}
		if (ever) {
		    if (text & Q(2)) {
			skip(side, size);
			move(fast, side, 1);
			skip(side, size);
			move(rule(node, size, 1), side, 1);

			ever = 0;
		    } else {
			dana(side, size);
			move(fast, side, 1);
		    }

		    text >>= 2;
		} else {
		    ever = 1;
		}
		slip = 2;
		if (ever) {
		    if (text & Q(2)) {
			skip(side, size);
			move(rule(node, size, 1), side, 1);

			skip(side, size);

			fast = road(tier, size);

			text >>= 1;
		    } else {
			dana(side, size);
			move(rule(node, size, 1), side, 1);

			skip(side, size);

			fast = road(tier, size);

			text >>= 2;

			if (fast < side) {
			    text >>= 1;
			    if (text & Q(1)) {
				move(fast, side, 1);
				dana(fast, size);
				slip += 2;
			    } else {
			    }

			    skip(side, size);
			}
		    }
		} else {
		    skip(side, size);

		    fast = road(tier, size);

		    if (fast < side) {
			text >>= 1;
			if (text & Q(1)) {
			    move(fast, side, 1);
			    dana(fast, size);
			    slip += 2;
			} else {
			}

			skip(side, size);
		    }
		}
		while (fast < side) {
		    if (text & Q(4)) {
			move(fast, side, 1);
			dana(fast, size);
			skip(side, size);
			move(fast, side, 1);
			dana(fast, size);
			skip(side, size);
			slip += 4;
		    } else {
			move(fast, side, 1);
			dana(fast, size);
			dana(side, size);
			slip += 2;
		    }

		    text >>= 2;
		}

		*(integral_q *) tier =
		    Lx55555555 | text >> 1 << (slip - 1) << 1;
	    }
#else
# error
#endif				/* __HALF_TRANSFER__ */
	} else {
	}
    } else {
	do {
#if __SINGLE_MERGE__
#else
	    void *club = NULL;
#endif				/* __SINGLE_MERGE__ */
	    void *fast;
#if __SINGLE_MERGE__
	    void *side;
#endif				/* __SINGLE_MERGE__ */

	    if (mind ^ 1) {
	    } else {
		status = _libx1f4l2_fold_bqfset
		    (bqfset, NULL, file, tier, 0, 2, node);
		if (1) {
		    break;
		}
	    }

#if __SINGLE_MERGE__
	    *(integral_q *) file = ~(Q(1) << integral_q_last);

	    side = rule(file, size, 4);

	    fast = sans(file, size);

	    deck = (integral_q_bits - 2 - 2) >> 1;

	    ever = deck >> 1;
	    for (; ever; ever--) {
		move(fast, side, 1);
		skip(fast, size);
		dana(side, size);
		move(fast, side, 1);
		skip(fast, size);
		dana(side, size);
	    }
	    {
		move(fast, rule(node, size, 0 + 1), 1);
		skip(fast, size);
	    }

	    side = road(tier, size);

	    deck = (integral_q_bits - 2) >> 1;

	    ever = deck >> 1;
	    for (; ever; ever--) {
		move(fast, side, 1);
		skip(fast, size);
		dana(side, size);
		move(fast, side, 1);
		skip(fast, size);
		dana(side, size);
	    }
	    if (deck & 1) {
		move(fast, side, 1);
		skip(fast, size);
		dana(side, size);
	    }

	    if (1) {
		void *side, **trap;

		trap = MD(node, size) + 1;

		mind--;

		memmove(trap, trap + 1, mind * sizeof(void *));

		side = sans(node, size);

		move(side, sans(side, size), mind);

		*(integral_q *) node = mind;

		status = bqfset(bqfset)->link_m.free
		    (bqfset(bqfset)->link_m.data, tier);
		if (status) {
		    status = FREE_ERROR;
		}
	    }
#else
	    if (0) {
	    } else {
		if (1) {
		    unsigned copy = 2, pick = 0;

		    _libx1f4l2_blue_bqfset
			(bqfset, &club, node, &pick, &file, &tier, &copy);
		    if (club) {
		    } else {
			break;
		    }
		}
	    }

	    if (1) {
		fast = file;

		fast = rule(fast, size, 2);

		if (1) {
		    deck = (half_integral_q_bits - 2) >> 1;

# if __UNROLL_TRANSFER__
#  error
# else
		    for (; deck; deck--) {
			move(fast, (char *) fast + (size << 1), 1);
			dana(fast, size);
		    }
# endif				/* __UNROLL_TRANSFER__ */
		}
	    }

	    {
		void *side;

		fast = club;

		*(integral_q *) club = Lxdddddddd ^ Q(1) << integral_q_last;

		if (0) {
		} else {
		    fast = rule(fast, size, 4);

		    side = life(fast, size);

		    move(side, fast, 1);
		    dana(fast, size);
		    skip(side, size);
		}

		deck = (integral_q_bits - 6) / 6;
		for (; deck; deck--) {
		    move(side, fast, 1);
		    dana(fast, size);
		    dana(side, size);
		    move(side, fast, 1);
		    dana(fast, size);
		    skip(side, size);
		    move(side, fast, 1);
		    dana(fast, size);
		    skip(side, size);
		}

		if (0) {
		} else {
		    if (half_integral_q_bits % 3 ^ 2) {
			move(side, fast, 1);

			fast = file;

			dana(fast, size);
			dana(side, size);
			move(side, rule(node, size, 1), 1);
			skip(side, size);
			move(side, fast, 1);
			skip(side, size);
		    } else {
			move(side, fast, 1);
			dana(fast, size);
			dana(side, size);
			move(side, fast, 1);

			fast = file;

			skip(side, size);
			move(side, rule(node, size, 1), 1);
			skip(side, size);
		    }
		}

		deck = integral_q_bits / 4 - integral_q_bits / 6 - 2;
		for (; deck; deck--) {
		    dana(fast, size);
		    move(side, fast, 1);
		    dana(side, size);
		    dana(fast, size);
		    move(side, fast, 1);
		    skip(side, size);
		    dana(fast, size);
		    move(side, fast, 1);
		    skip(side, size);
		}

		{
		    dana(fast, size);
		    move(side, fast, 1);
		    dana(side, size);
		    dana(fast, size);
		    move(side, fast, 1);
		}

		fast = rule(tier, size, integral_q_bits);

		side = fast;

		deck = integral_q_bits / 6;
		for (; deck; deck--) {
		    posh(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		    posh(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		    beta(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		}

		if (0) {
		} else {
		    if (half_integral_q_bits % 3 ^ 2) {
			fast = rule(file, size, integral_q_bits - 2);

			posh(side, size);
			move(side, rule(node, size, 2), 1);
			posh(side, size);
			move(side, fast, 1);
			beta(side, size);
			beta(fast, size);
			move(side, fast, 1);
		    } else {
			posh(side, size);
			beta(fast, size);
			move(side, fast, 1);

			fast = rule(file, size, integral_q_bits - 2);

			posh(side, size);
			move(side, rule(node, size, 2), 1);
			beta(side, size);
			move(side, fast, 1);
		    }
		}

		deck = integral_q_bits / 4 - integral_q_bits / 6 - 2;
		for (; deck; deck--) {
		    posh(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		    posh(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		    beta(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		}

		{
		    posh(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		    posh(side, size);
		    beta(fast, size);
		    move(side, fast, 1);
		}

		*(integral_q *) tier = Lxdddddddd;
	    }

	    if (1) {
		void *side, **trap;

		trap = MD(node, size) + 1;

		mind--;

		memmove(trap, trap + 1, mind * sizeof(void *));

		side = rule(node, size, 1);

		move(side, cell(fast, size, 4), 1);

		skip(side, size);

		mind - 1, maybe?
		move(side, sans(side, size), mind);

		*(integral_q *) node = mind;

		status = bqfset(bqfset)->link_m.free
		    (bqfset(bqfset)->link_m.data, file);
		if (status) {
		    status = FREE_ERROR;
		}
	    }
#endif				/* __SINGLE_MERGE__ */
	} while (0);
    }

    return status;
}
