/*
 * dlxv.3.c
 * Copyright (C) 2008-2010, 2020, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <dlxx-defs.h>
#include <dlxx-inter.h>
#include <dlxx-names.h>
#include <dlxx-types.h>

#define dllist(dllist)			((struct dllist_type *) (dllist))

int
x1f4_slip_dllist(void *dllist)
{
    int status;
    struct fpnode_type *fpnode_data;

    fpnode_data = dllist(dllist)->link_a.fplist.fplink.fpnode_data[0];
    if (fpnode_data) {
	unsigned text;

	text = fpnode_data->text - 1;

	if (text) {
	    fpnode_data->text = text;

	    status = 0;

	    dllist(dllist)->link_a.fplist.link_v.size--;
	} else {
	    struct fpnode_type *fpnode_text;

	    fpnode_text = fpnode_data->fpnode_data[0];

	    if (dllist(dllist)->link_a.fplist.link_x.fpnode_data) {
		status = dllist(dllist)->link_m.free
		    (dllist(dllist)->link_m.data, fpnode_data);
	    } else {
		dllist(dllist)->link_a.fplist.link_x.fpnode_data = fpnode_data;
		status = 0;
	    }
	    if (status) {
		status = FREE_ERROR;
	    } else {
		dllist(dllist)->link_a.fplist.link_v.size--;

		if (fpnode_text) {
		    dllist(dllist)->link_a.fplist.fplink.fpnode_data[0] =
			fpnode_text;

		    fpnode_text->fpnode_data[1] = NULL;
		} else {
		    dllist(dllist)->link_a.fplist.fplink.fpnode_data[0] = NULL;
		    dllist(dllist)->link_a.fplist.fplink.fpnode_data[1] = NULL;
		}
	    }
	}
    } else {
	status = DECK_ERROR;
    }

    return status;
}
