/*
 * e2list.1.c
 * Copyright (C) 2008-2011, 2013, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e2list-defs.h>
#include <e2list-inter.h>
#include <e2list-types.h>

static int fini_list(struct e2list_type *);
static int flat_list(struct e2list_type *);

static int
fini_list(struct e2list_type *e2list_data)
{
    int (*free) (void *, void *), status;
    void *data;

    data = e2list_data->link_m.data;
    free = e2list_data->link_m.free;

    if (0) {
    } else {
	status = free(data, e2list_data);
	if (status) {
	    status = FREE_ERROR;
	}
    }

    return status;
}


static int
flat_list(struct e2list_type *e2list_data)
{
    int excess, status;

    status = _libx1f4i0_side_e2list(e2list_data);

    excess = _libx1f4i0_deck_e2list(e2list_data);
    if (excess) {
        if (status) {
	} else {
	    status = excess;
	}
    }

    e2list_data->link_i.deck = e2list_data->link_i.hold;

    excess = _libx1f4i0_fine_e2list(e2list_data);
    if (excess) {
        if (status) {
	} else {
	    status = excess;
	}
    }

    return status;
}


int
x1f4_fini_e2list(void **e2list, void *line)
{
    int excess, status;

    status = flat_list(*e2list);

    excess = fini_list(*e2list);
    if (excess) {
	if (status) {
	} else {
	    status = excess;
	}
    }

    return status;
}
