/*
 * e2list.9.c
 * Copyright (C) 2008-2011, 2013, 2014, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e2list-defs.h>
#include <e2list-inter.h>
#include <e2list-types.h>

#define __not_set_by_link__		0

#define e2list(delete) \
    ((struct e2list_type *) (delete))

int
x1f4_pick_e2list(void *e2list, void ***text, int (*miss)(void *),
		 unsigned size, void **link)
{
    int status;
    unsigned bind, deck, flow, slip;
    void *data;

#if 0
    deck = sizeof(struct e2text_type);
    deck += (16 - (deck & 15)) & 15;

    flow = size + deck;

    status = x1f4_link_e2list(e2list, &data, flow);
#else
    bind = sizeof(struct e2node_type);
    bind += (16 - (bind & 15)) & 15;
    deck = sizeof(struct e2text_type);
    deck += (16 - (deck & 15)) & 15;

    flow = size + deck + bind;

    slip = e2list(e2list)->link_i.slip;

    if (LINK_SIZE < flow || !~slip) {
	status = x1f4_link_e2list
	    (e2list, &data, flow - sizeof(struct e2node_type));
    } else {
	do {
	    struct e2node_type *e2node_data;
	    void *fine;

	    fine = e2list(e2list)->link_i.fine;

	    if (FINE_SIZE < slip + flow) {
		void *land;

		status = e2list(e2list)->link_a.link
		    (e2list(e2list)->link_a.data, &land, FINE_SIZE);
		if (status) {
		    break;
		} else {
		    slip = sizeof(struct e2fine_type);
		    slip += (16 - (slip & 15)) & 15;

		    e2list(e2list)->link_i.fine = land;

		    ((struct e2fine_type *) land)->e2fine_data = fine;

		    fine = land;
		}
	    } else {
		status = 0;
	    }

	    e2node_data = (void *) ((char *) fine + slip);

	    e2node_data->size = flow - bind;

	    data = (char *) e2node_data + bind;

	    flow += (16 - (flow & 15)) & 15;

	    e2list(e2list)->link_i.slip = slip + flow;

	    if (__not_set_by_link__) {
	    } else {
		int *class;

		class = e2list(e2list)->link_l.class;
		if (class) {
		    *class = 1;
		}
	    }
	} while (0);
    }
#endif				/* 0 */
    if (status) {
    } else {
	struct e2text_type *e2text_data, *list_e2text;

	e2text_data = data;

	list_e2text = e2list(e2list)->link_c.list;
	e2list(e2list)->link_c.list = e2text_data;

	e2text_data->next_e2text = list_e2text;

	e2text_data->miss = miss;

	*text = &e2text_data->text;

	if (link) {
	    *link = (void *) ((char *) e2text_data + deck);
	}

	if (__not_set_by_link__) {
	    int *class;

	    class = e2list(e2list)->link_l.class;
	    if (class) {
		*class = 1;
	    }
	}
    }

    return status;
}
