/*
 * e4.b.c
 * Copyright (C) 2006-2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4-defs.h>
#include <e4-inter.h>
#include <e4-types.h>

int
_x1f4_e4_lead_side(struct e4_atom_type *atom_data)
{
    const struct e4_ever_type *ever_data;
    int type;

    ever_data = atom_data->data.ever.ever_data;

    type = ever_data->type;
    if (ever_data->bits & UNIVERSAL) {
	if (ever_data->bits & REFERENCE) {
	    if (type == BILL) {
		atom_data->load = _x1f4_e4_load_Will;
	    } else if (type == MODE) {
		atom_data->load = _x1f4_e4_load_Node;
	    } else if (type == REAL) {
		atom_data->load = _x1f4_e4_load_Teal;
	    } else if (type == TEXT) {
		atom_data->load = _x1f4_e4_load_Next;
	    } else {
		atom_data->load = _x1f4_e4_load_Over;
	    }
	} else {
	    if (type == BILL) {
		atom_data->load = _x1f4_e4_load_WILL;
	    } else if (type == MODE) {
		atom_data->load = _x1f4_e4_load_NODE;
	    } else if (type == REAL) {
		atom_data->load = _x1f4_e4_load_TEAL;
	    } else if (type == TEXT) {
		atom_data->load = _x1f4_e4_load_NEXT;
	    } else {
		atom_data->load = _x1f4_e4_load_OVER;
	    }
	}
    } else {
	if (ever_data->bits & REFERENCE) {
	    if (type == BILL) {
		atom_data->load = _x1f4_e4_load_Bill;
	    } else if (type == MODE) {
		atom_data->load = _x1f4_e4_load_Mode;
	    } else if (type == REAL) {
		atom_data->load = _x1f4_e4_load_Real;
	    } else if (type == TEXT) {
		atom_data->load = _x1f4_e4_load_Text;
	    } else {
		atom_data->load = _x1f4_e4_load_User;
	    }
	} else {
	    if (type == BILL) {
		atom_data->load = _x1f4_e4_load_BILL;
	    } else if (type == MODE) {
		atom_data->load = _x1f4_e4_load_MODE;
	    } else if (type == REAL) {
		atom_data->load = _x1f4_e4_load_REAL;
	    } else if (type == TEXT) {
		atom_data->load = _x1f4_e4_load_TEXT;
	    } else {
		atom_data->load = _x1f4_e4_load_USER;
	    }
	}
    }

    return 0;
}

