/*
 * file.e.3.c
 * Copyright (C) 2008-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <file-defs.h>
#include <file-types.h>
#include <trans.h>

#define data(file, offset) \
    ((char *) (file(file) + 1) + (offset))

#define file(file) \
    ((struct eifile_type *) (file))

extern const char *const x1f4_c1_empty_string;

int
_libx1f4i0_copy_ndata(void *file, unsigned miss, unsigned ever, unsigned fast,
		      void **line, unsigned *size,
		      struct trans_type *trans_data)
{
    int status;

    if (fast) {
	do {
	    char *text;
	    void *data;

	    if (*size) {
		status = trans_data->mode(trans_data->data, line, fast + 1);
		if (status) {
		    status = MODE_CLASS;
		    break;
		}
	    } else {
		status = trans_data->link(trans_data->data, line, fast + 1);
		if (status) {
		    status = LINK_CLASS;
		    break;
		}
	    }

	    data = *line;

	    memcpy(data, data(file, ever), fast);
	    text = data;
	    text[fast] = 0;

	    *size = fast;

	    fast++;

	    file(file)->ever = ever + fast;
	    file(file)->size = miss - fast;
	} while (0);
    } else {
	do {
	    if (*size) {
		status = trans_data->free(trans_data->data, *line);
		if (status) {
		    status = FREE_CLASS;
		    break;
		}
	    }

	    *line = (void *) x1f4_c1_empty_string;

	    *size = 0;

	    file(file)->ever = ever + 1;
	    file(file)->size = miss - 1;

	    status = 0;
	} while (0);
    }

    return status;
}
