/*
 * file.i.t.c
 * Copyright (C) 2008-2013, 2016, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <dirent.h>
#include <stddef.h>

#include <sys/types.h>

#include <file-defs.h>
#include <file-types.h>

#define file(file) \
    ((struct eifile_type *) (file))

extern const struct sffile_type _libx1f4_file_i_shfile;

int
_libx1f4i0_roll_ifile(void *file, const char *path)
{
    DIR *roll;
    int status;

    roll = opendir(path);
    if (roll) {
	struct cdfile_type *edfile_data;

	edfile_data = (void *) &file(file)->sd;

	edfile_data->data = roll;

	file(file)->size = 0;

	file(file)->sf = &_libx1f4_file_i_shfile;

	status = 0;
    } else {
	status = OPEN_CLASS;
    }

    return status;
}
