/*
 * ix.2.c
 * Copyright (C) 2008-2012, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <ix-types.h>

int
x1f4_lock_indexset(void *context, int to, int from,
		   const struct x1f4_linetext_type **linetext)
{
    int delete = 1;
    const struct indexset_type *indexset_data;
    const struct x1f4_composer_type *composer_data;
    unsigned miss;

    indexset_data = context;

    composer_data = indexset_data->composer_set.composer_data;

    miss = indexset_data->composer_set.miss;
    for (; miss; miss--) {
	delete = composer_data->link(composer_data->text, to, from, linetext);
	if (delete != 1) {
	    break;
	} else {
	    composer_data++;
	}
    }

    return delete;
}
