/*
 * lxcase-c.g.c
 * Copyright (C) 2016, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <unistd.h>

#include <sys/stat.h>

#include <lxcase-drive.h>
#include <lxcase-inter.h>
#include <lxcase-types.h>

static int stat_file(void *, void *, void *);

static int
stat_file(void *context, void *fare, void *info)
{
    int status;

    status = fstat(I_MODE(fare), info);
    if (status) {
	status = _libx1f4i0_lxcase_stat_fall(context, "fstat", I_MODE(fare));
    }

    return status;
}


int
_libx1f4i0_lxcase_i190702_0(void *context, void *output, void **input)
{
    return _libx1f4i0_lxcase_half_file(context, output, input, stat_file);
}
