/*
 * lxcast-i.j.c
 * Copyright (C) 2010-2014, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxcast-inter.h>
#include <lxcast-types.h>

#define I_USER(u)			(*((X1f4_E4_C_USER *) (u)))

#define lxcast(lxcast) \
    ((struct lxcast_type *) (lxcast))

int
_libx1f4i0_lxcast_long_type(void *context, void *output, void **input,
			    int type)
{
    int status;

    do {
	int name;
	struct x1f4_composer_type *composer_data;
	struct dxcast_type *object_data;

	object_data = I_USER(input[0]);

	name = object_data->type;

	composer_data = &lxcast(context)->link_q;
	if (composer_data->link) {
	    const struct x1f4_linetext_type *linetext_data;

	    status = composer_data->link
		(composer_data->text, type, name, &linetext_data);
	    if (status) {
	    } else {
		void *track;

		track = &object_data->data;
		status = linetext_data->function.function
		    ((void *) linetext_data->context, output,
		     &track);
		if (status) {
		    break;
		} else {
		    break;
		}
	    }
	}

	status = _libx1f4i0_lxcast_stat_luck(context, 0, name, type);
    } while (0);

    return status;
}
