/*
 * lxcast-i.q.c
 * Copyright (C) 2010, 2011, 2013-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxcast-inter.h>
#include <lxcast-types.h>

#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

int
_libx1f4i0_lxcast_q_indexed(void *context, void *output, void **input)
{
    int status;
    struct dxcast_type *object_data;
    struct lxcast_type *lxcast_data;
    struct x1f4_function_type *function_data;

    function_data = ((void **) input[-1])[X1f4_E4_RENDITION];

    lxcast_data = context;

    object_data = I_USER(input[1]);

    if (object_data->type ^ function_data->type) {
	status = _libx1f4i0_lxcast_stat_luck
	    (lxcast_data, 1, object_data->type, function_data->type);
    } else {
	void *white[2];

	white[0] = input[0];
	white[1] = &object_data->data;

	status = _libx1f4i0_lxcast_r_indexed(lxcast_data, output, white);
    }

    return status;
}
