/*
 * lxdash-b.0-s.c
 * Copyright (C) 2008-2015, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxcall.h>
#include <lxdash-drive.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define l_BILL(e, output) \
    {									      \
	X1f4_E4_C_BILL *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxdash_0_point_b(void *context, void *output, void **input)
{
    int status;
    struct cxseek_type *cxseek_data;
    struct dxdash_type *dxdash_data;
    struct effect_type effect;
    void *data;

    cxseek_data = context;

    dxdash_data = I_LINE(input[1]);

    effect.mode = I_MODE(input[2]);

    status = cxseek_data->seek(dxdash_data->dash, &effect, &data);
    if (status) {
	struct effect_type *effect_data;
	unsigned type;

	effect_data = data;

	type = effect_data->type;
	if (type != X1f4_E4_BILL) {
	    status = _libx1f4i0_lxdash_stat_type
		(cxseek_data->line, effect_data->mode, type, X1f4_E4_BILL);
	} else {
	    l_MODE(effect_data->mode, input[3]);
	    if (0) {
	    } else {
		l_BILL(I_BILL(&effect_data->fxdata), input[0]);
		l_MODE(1, output);
		if (1) {
		    status = 0;
		}
	    }
	}
    } else {
	if (0) {
	} else {
	    l_MODE(0, output);
	    if (1) {
		status = 0;
	    }
	}
    }

    return status;
}
