/*
 * lxdash-b.q-c.c
 * Copyright (C) 2008-2015, 2017, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <e4.h>
#include <lxdash-drive.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define l_BILL(e, output) \
    {									      \
	X1f4_E4_C_BILL *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

#define lxtext(lxtext)			((struct lxtext_type *) (lxtext))

int
_libx1f4i0_lxdash_q_press_b(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data;
    struct effect_type effect;
    void *data;

    dxdash_data = I_LINE(input[0]);

    effect.mode = I_MODE(input[1]);

    status = x1f4_find_lxfset(dxdash_data->dash, &effect, &data);
    if (status) {
	struct effect_type *effect_data;
	unsigned type;

	status = 0;

	effect_data = data;

	type = effect_data->type;
	switch (type) {
	case X1f4_E4_BILL:
	    l_BILL(I_BILL(&effect_data->fxdata), output);
	    break;
	case X1f4_E4_MODE:
	    l_BILL(I_MODE(&effect_data->fxdata), output);
	    break;
	case X1f4_E4_REAL:
	    l_BILL(I_REAL(&effect_data->fxdata), output);
	    break;
	default:
	    status = _libx1f4i0_lxdash_stat_type
		(lxtext(context)->text, effect.mode, type, X1f4_E4_BILL);
	}
    } else {
	status = _libx1f4i0_lxdash_stat_miss
	    (lxtext(context)->text, effect.mode);
    }

    return status;
}
