/*
 * lxdash-b.q.0.c
 * Copyright (C) 2008-2015, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxdash-drive.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define l_BILL(e, output) \
    {									      \
	X1f4_E4_C_BILL *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxdash_q0class_b(void *context, void *output, void **input)
{
    int status;
    struct cxbend_type *cxbend_data;
    struct dxdash_type *dxdash_data;
    void *data;

    cxbend_data = context;

    dxdash_data = I_LINE(input[0]);

    status = cxbend_data->pick(dxdash_data->dash, &data);
    if (status) {
	status = _libx1f4i0_lxdash_stat_line(cxbend_data->line, 0, status);
    } else {
	struct effect_type *effect_data;
	unsigned type;

	effect_data = data;

	type = effect_data->type;
	if (type != X1f4_E4_BILL) {
	    status = _libx1f4i0_lxdash_stat_ends
		(cxbend_data->line, cxbend_data->bend, type, X1f4_E4_BILL);
	} else {
	    l_BILL(I_BILL(&effect_data->fxdata), output);
	}
    }

    return status;
}
