/*
 * lxdash-l.s.c
 * Copyright (C) 2008-2015, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <e4.h>
#include <fd.h>
#include <lxdash-drive.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

int
_libx1f4i0_lxdash_s_logique(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data;
    struct effect_type effect;
    struct lxdash_type *lxdash_data;
    void *data;

    dxdash_data = I_LINE(input[0]);

    lxdash_data = context;

    effect.mode = I_MODE(input[1]);

    status = x1f4_find_lxfset(dxdash_data->dash, &effect, &data);
    if (status) {
	void *text;

	effect.mode = I_MODE(input[2]);

	status = x1f4_find_lxfset(dxdash_data->dash, &effect, &text);
	if (status) {
	    struct effect_type *effect_data, *effect_text;

	    effect_data = data;
	    effect_text = text;

	    effect = *effect_text;

	    effect_text->fxdata = effect_data->fxdata;
	    effect_text->link = effect_data->link;
	    effect_text->type = effect_data->type;

	    effect_data->fxdata = effect.fxdata;
	    effect_data->link = effect.link;
	    effect_data->type = effect.type;

	    status = 0;
	} else {
	    status = _libx1f4i0_lxdash_stat_miss(lxdash_data, effect.mode);
	}
    } else {
	status = _libx1f4i0_lxdash_stat_miss(lxdash_data, effect.mode);
    }

    return status;
}
