/*
 * lxdash-t.j.c
 * Copyright (C) 2008-2015, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <d_fset.h>
#include <e4.h>
#include <lxcall.h>
#include <lxdash-drive.h>
#include <lxdash-types.h>

int
_libx1f4i0_lxdash_j_class_t(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data;
    struct effect_type effect;
    struct lxdash_type *lxdash_data;
    struct lxtext_type *lxtext_data;
    void *data;

    lxtext_data = context;

    lxdash_data = lxtext_data->text;

    dxdash_data = I_LINE(input[1]);

    effect.mode = I_MODE(input[2]);

    status = x1f4_find_lxfset(dxdash_data->dash, &effect, &data);
    if (status) {
	struct effect_type *effect_data;
	unsigned type;

	status = 0;

	effect_data = data;

	type = effect_data->type;
	if (type != X1f4_E4_TEXT) {
	    l_MODE(0, output);
	    if (1) {
		status = 0;
	    }
	} else {
	    X1f4_E4_C_TEXT post;

	    l_MODE(1, output);

	    post = I_TEXT(&effect_data->fxdata);

	    status = _libx1f4i0_lxcall_swap_text
		(&lxdash_data->ever_a, *input, post, strlen(post) + 1);
	}
    } else {
	l_MODE(0, output);
    }

    return status;
}
