/*
 * lxdash-t.x.0.c
 * Copyright (C) 2008-2015, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxcall.h>
#include <lxdash-drive.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

int
_libx1f4i0_lxdash_x0class_t(void *context, void *output, void **input)
{
    int status;
    struct cxbend_type *cxbend_data;
    struct dxdash_type *dxdash_data;
    struct lxdash_type *lxdash_data;
    void *data;

    cxbend_data = context;

    lxdash_data = cxbend_data->line;

    dxdash_data = I_LINE(input[0]);

    status = cxbend_data->pick(dxdash_data->dash, &data);
    if (status) {
	status = _libx1f4i0_lxdash_stat_line(lxdash_data, 0, status);
    } else {
	struct effect_type *effect_data;
	unsigned type;

	effect_data = data;

	type = effect_data->type;
	if (type != X1f4_E4_TEXT) {
	    status = _libx1f4i0_lxdash_stat_ends
		(lxdash_data, cxbend_data->bend, type, X1f4_E4_TEXT);
	} else {
	    status = _libx1f4i0_lxcall_pick_text
		(&lxdash_data->ever_a, &effect_data->fxdata);
	    if (status) {
	    } else {
		l_TEXT(I_TEXT(&effect_data->fxdata), output);

		effect_data->link = ~0;

		status = cxbend_data->slip(dxdash_data->dash);
		if (status) {
		    status =
			_libx1f4i0_lxdash_stat_line(lxdash_data, 0, status);
		} else {
		    dxdash_data->size--;
		}
	    }
	}
    }

    return status;
}
