/*
 * lxdata-a.k.c
 * Copyright (C) 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxdata-types.h>

#define lxdata(lxdata) \
    ((struct lxdata_type *) (lxdata))

int
x1f4_lock_lxdata(void *context, int outer, int inner,
		 const struct x1f4_linetext_type **linetext)
{
    int delete = 1;

    if (outer == X1f4_E4_TEXT) {
	if (inner == lxdata(context)->link_t.datatype[0].type) {
	    const struct x1f4_linetext_type *linetext_data;

	    linetext_data = lxdata(context)->late_f.b_string;
	    if (linetext_data) {
		*linetext = linetext_data;
		delete = 0;
	    }
	}
    } else {
	if (inner == X1f4_E4_TEXT) {
	    if (outer == lxdata(context)->link_t.datatype[0].type) {
		const struct x1f4_linetext_type *linetext_data;

		linetext_data = lxdata(context)->late_f.b_draft;
		if (linetext_data) {
		    *linetext = linetext_data;
		    delete = 0;
		}
	    }
	}
    }

    return delete;
}
