/*
 * lxdata-d.a.c
 * Copyright (C) 2008-2013, 2017, 2019, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lintegral-x.h>
#include <lxdata-drive.h>
#include <lxdata-inter.h>
#include <lxdata-types.h>

int
_libx1f4i0_lxdata_a_derived(void *context, void *output, void **input)
{
    X1f4_E4_C_MODE base;
    int status;

    base = I_MODE(input[1]);

    if (base < 0 || base == 1 || 36 < base) {
	status = _libx1f4i0_lxdata_stat_base(context, base);
    } else {
	char *text;
	long class;

	text = ((struct dxdata_type *) I_DATA(input[0]))->string;

	status = x1f4_parse_xlintegral(&class, text, NULL, base);
	if (status) {
	    status = _libx1f4i0_lxdata_stat_line(context, text);
	} else {
	    l_MODE(class, output);
	}
    }

    return status;
}
