/*
 * lxdata-d.c-p.c
 * Copyright (C) 2008-2011, 2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <e4.h>
#include <lxdata-inter.h>
#include <lxdata-types.h>

#define I_DATA(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxdata_cpderived(void *context, void *output, void **input)
{
    int status;

    do {
	X1f4_E4_C_MODE mode;
	int delete;
	struct dxdata_type *dxdata_data, *dxdata_text;
	unsigned data, size, text;

	dxdata_data = I_DATA(input[0]);

	mode = I_MODE(input[1]);

	data = dxdata_data->length + 1;

	if (mode < 0) {
	    if ((X1f4_E4_C_MODE) data < -mode) {
		status = _libx1f4i0_lxdata_stat_deck(context, data, mode);
		if (1) {
		    break;
		}
	    } else {
		mode = data + mode;
	    }
	} else {
	    if (mode < data) {
	    } else {
		status = _libx1f4i0_lxdata_stat_deck(context, data, mode);
		if (1) {
		    break;
		}
	    }
	}

	--data;

	dxdata_text = I_DATA(input[2]);

	text = dxdata_text->length;

	data -= mode;

	status = 0;

	if (data ^ text) {
	    size = data < text ? data : text;
	} else {
	    size = data;
	}

	delete = memcmp(dxdata_data->string + mode, dxdata_text->string, size);
	if (delete) {
	} else {
	    if (size ^ data) {
		delete = 256;
	    } else {
		if (size ^ text) {
		    delete = -256;
		}
	    }
	}

	l_MODE(delete, output);
    } while (0);

    return status;
}
