/*
 * lxdata-n.u.c
 * Copyright (C) 2013, 2014, 2017, 2020, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxdata-drive.h>
#include <lxdata-types.h>

int
_libx1f4i0_lxdata_u_nearest(void *context, void *output, void **input)
{
    struct dxdata_type *dxdata_data;
    unsigned c, size;
    unsigned char *data;

    dxdata_data = I_DATA(input[0]);

    size = dxdata_data->length;
    data = (unsigned char *) dxdata_data->string;

    for (; size; size--, data++) {
	c = *data;
	if (c < 'a' || 'z' < c) {
	} else {
	    *data = c ^ 'A' ^ 'a';
	}
    }

    l_DATA(dxdata_data, output);

    return 0;
}
