/*
 * lxdecq-k.a.c
 * Copyright (C) 2008-2011, 2013, 2014, 2016-2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <f_list.h>
#include <lxdecq-drive.h>
#include <lxdecq-inter.h>
#include <lxdecq-types.h>

int
_libx1f4i0_lxdecq_a_keeping(void *context, void *output, void **input)
{
    int status;
    struct cxbend_type *cxbend_data;
    struct dxlist_type *dxlist_data;
    struct lxdecq_type *lxdecq_data;
    unsigned size;

    cxbend_data = context;

    lxdecq_data = cxbend_data->list;

    dxlist_data = I_LIST(input[0]);

    size = dxlist_data->size;
    if (!size) {
	status = _libx1f4i0_lxdecq_stat_null(lxdecq_data);
    } else {
	void *data;

	status = cxbend_data->pick(dxlist_data->list, &data);
	if (status) {
	    status = _libx1f4i0_lxdecq_stat_list(lxdecq_data, 0, status);
	} else {
	    do {
		unsigned link;

		link = effect_link(data);
		if (~link) {
		    int (*free)(void *, void *, struct excase_type **,
				const struct excase_type *);
		    struct lxtext_type *lxtext_link;

		    lxtext_link =
			((struct lxtext_type *)
			 lxdecq_data->link_f.text) + link;

		    free = lxtext_link->lxtype.free;
		    if (free) {
			status = free
			    (lxtext_link->lxtype.context,
			     E_USER(data), NULL,
			     lock_excase(dxlist_data));
			if (status) {
			    break;
			}
		    }
		}

		status = cxbend_data->slip(dxlist_data->list);
		if (status) {
		    status = _libx1f4i0_lxdecq_stat_list
			(lxdecq_data, 0, status);
		} else {
		    dxlist_data->size = size - 1;

		    l_LIST(dxlist_data, output);
		}
	    } while (0);
	}
    }

    return status;
}

