/*
 * lxdecq-t.e.0.c
 * Copyright (C) 2008-2010, 2013-2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <f_list.h>
#include <lxdecq-drive.h>
#include <lxdecq-inter.h>
#include <lxdecq-types.h>
#include <lxnext.h>

int
_libx1f4i0_lxdecq_e0class_t(void *context, void *output, void **input)
{
    int status;
    struct cxbend_type *cxbend_data;
    struct dxlist_type *dxlist_data;
    struct lxdecq_type *lxdecq_data;
    void *data;

    cxbend_data = context;

    lxdecq_data = cxbend_data->list;

    dxlist_data = I_LIST(input[1]);

    status = cxbend_data->pick(dxlist_data->list, &data);
    if (status) {
	status = _libx1f4i0_lxdecq_stat_list(lxdecq_data, 0, status);
    } else {
	unsigned type;

	type = effect_type(data);
	if (type != X1f4_E4_TEXT) {
	    status = _libx1f4i0_lxdecq_stat_ends
		(lxdecq_data, cxbend_data->bend, type, X1f4_E4_TEXT);
	} else {
	    status = _libx1f4i0_lxnext_push_text
		(&lxdecq_data->ever_a, input[0],
		 E_TEXT(data), lock_excase(dxlist_data));
	    if (status) {
	    } else {
		link_effect(data, ~0);

		status = cxbend_data->slip(dxlist_data->list);
		if (status) {
		    status = _libx1f4i0_lxdecq_stat_list
			(lxdecq_data, 0, status);
		} else {
		    dxlist_data->size--;


		    l_TEXT(I_TEXT(*input), output);
		}
	    }
	}
    }

    return status;
}
