/*
 * lxfile-d.l.c
 * Copyright (C) 2008-2010, 2013, 2014, 2016, 2020, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <exerrors.h>
#include <file.h>
#include <lxfile-defs.h>
#include <lxfile-drive.h>
#include <lxfile-inter.h>
#include <lxfile-types.h>
#include <trans.h>

extern int x1f4_warp_lxlist
    (void *, void *, void **, int (**)(void *, void *, unsigned));

int
_libx1f4i0_lxfile_l_derived(void *context, void *output, void **input)
{
    int status;

    do {
	int (*fast)(void *, void *, unsigned);
	struct dxfile_type *dxfile_data;
	struct lxfile_type *lxfile_data;
	unsigned size;
	void *file, *warp[4];

	dxfile_data = I_FILE(input[0]);

	lxfile_data = context;

	file = dxfile_data->file;

	if (dxfile_data->mode != READ_CLASS) {
	    status = _libx1f4i0_lxfile_stat_turn(lxfile_data, dxfile_data);
	    if (1) {
		break;
	    }
	}

	status = x1f4_warp_lxlist
	    (lxfile_data->link_l.list, I_LIST(input[1]), warp, &fast);
	if (status) {
	} else {
	    status = _libx1f4i0_list_ifile
		(file, warp, &size, I_MODE(input[2]), NULL, 0, fast,
		 warp[3], warp[3]);
	    if (status) {
		if (status == FILE_OVER_CLASS) {
		    status = 0;
		    l_MODE(-1, output);
		} else {
		    status = _libx1f4i0_lxfile_stat_file(lxfile_data, status);
		}
	    } else {
		l_MODE(size, output);
	    }
	}
    } while (0);

    return status;
}
