/*
 * lxline-l.n.c
 * Copyright (C) 2008-2015, 2017, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <fd.h>
#include <l_note.h>
#include <lxcall.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

int
_libx1f4i0_lxline_n_logique(void *context, void *output, void **input)
{
    int status;

    do {
	struct dxline_type *dxline_data;
	struct lxline_type *lxline_data;
	struct lxtext_type *lxtext_data;
	void *data;

	lxtext_data = context;

	dxline_data = I_LINE(input[0]);

	lxline_data = lxtext_data->text;

	status = _libx1f4i0_post_sfnote
	    (dxline_data->line, I_TEXT(input[1]),
	     effect_size, &data);
	if (status) {
	    status = _libx1f4i0_lxline_stat_line(lxline_data, 0, status);
	} else {
	    unsigned link, type;
	    void *post;

	    type = lxtext_data->lxtype.code;

	    type_effect(data, type);

	    status = lxtext_data->lxtype.post
		(lxtext_data->lxtype.context, &post, lock_excase(dxline_data));
	    if (status) {
		link_effect(data, ~0);

		_libx1f4i0_pass_sfnote(dxline_data->line, I_TEXT(input[1]));

		break;
	    } else {
		l_USER(post, effect_data(data));

		dxline_data->size++;

		link = lxtext_data
		    - ((struct lxtext_type *) lxline_data->link_f.text);

		if (lxtext_data->lxtype.lead) {
		    status = x1f4_auto_node
			(&lxline_data->link_v, &lxline_data->link_e,
			 &lxtext_data->lxtype, &post, output);
		} else {
		    l_USER(post, output);
		}
	    }

	    link_effect(data, link);
	}
    } while (0);

    return status;
}
