/*
 * lxline-l.v.c
 * Copyright (C) 2008-2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <fd.h>
#include <l_note.h>
#include <lxcall.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

int
_libx1f4i0_lxline_v_logique(void *context, void *output, void **input)
{
    int status;
    X1f4_E4_C_TEXT fail;
    struct dxline_type *dxline_data;
    void *data;

    dxline_data = I_LINE(input[0]);

    fail = I_TEXT(input[1]);

#if 0
    status = _libx1f4i0_find_sfnote(dxline_data->line, fail, &data);
    if (status) {
	struct lxtext_type *lxtext_data;
	unsigned type;

	status = 0;

	lxtext_data = context;

	type = effect_type(data);
	if (type != lxtext_data->lxtype.code) {
	    status = _libx1f4i0_lxline_stat_type
		(lxtext_data->text, fail, type, lxtext_data->lxtype.code);
	} else {
	    struct lxline_type *lxline_data;

	    lxline_data = lxtext_data->text;

	    if (lxtext_data->lxtype.lead) {
		status = x1f4_auto_node
		    (&lxline_data->link_v, &lxline_data->link_e,
		     &lxtext_data->lxtype, effect_data(data), output);
	    } else {
		l_USER(E_USER(data), output);
	    }
	}
    } else {
	status = _libx1f4i0_lxline_n_logique(context, output, input);
    }
#else
    do {
	struct lxline_type *lxline_data;
	struct lxtext_type *lxtext_data;

	lxtext_data = context;

	dxline_data = I_LINE(input[0]);

	lxline_data = lxtext_data->text;

	status = _libx1f4i0_post_sfnote
	    (dxline_data->line, fail, effect_size, &data);
	if (status) {
	    if (status == X1f4_SFNOTE_EVER_MATCH) {
		unsigned type;

		status = 0;

		type = effect_type(data);
		if (type != lxtext_data->lxtype.code) {
		    status = _libx1f4i0_lxline_stat_type
			(lxtext_data->text, fail, type,
			 lxtext_data->lxtype.code);
		} else {
		    if (lxtext_data->lxtype.lead) {
			status = x1f4_auto_node
			    (&lxline_data->link_v, &lxline_data->link_e,
			     &lxtext_data->lxtype, effect_data(data), output);
		    } else {
			l_USER(E_USER(data), output);
		    }
		}
	    } else {
		status =
		    _libx1f4i0_lxline_stat_line(lxtext_data->text, 0, status);
	    }
	} else {
	    unsigned link, type;
	    void *post;

	    type = lxtext_data->lxtype.code;

	    type_effect(data, type);

	    status = lxtext_data->lxtype.post
		(lxtext_data->lxtype.context, &post,
		 lock_excase(dxline_data));
	    if (status) {
		link_effect(data, ~0);

		_libx1f4i0_pass_sfnote(dxline_data->line, fail);

		break;
	    } else {
		l_USER(post, effect_data(data));

		dxline_data->size++;

		link = lxtext_data
		    - ((struct lxtext_type *) lxline_data->link_f.text);

		if (lxtext_data->lxtype.lead) {
		    status = x1f4_auto_node
			(&lxline_data->link_v, &lxline_data->link_e,
			 &lxtext_data->lxtype, &post, output);
		} else {
		    l_USER(post, output);
		}
	    }

	    link_effect(data, link);
	}
    } while (0);
#endif				/* 0 */

    return status;
}
