/*
 * lxlist-k.b.c
 * Copyright (C) 2008-2011, 2013, 2014, 2016-2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <copy.h>
#include <e4.h>
#include <l_list.h>
#include <lxcast.h>
#include <lxlist-close.h>
#include <lxlist-drive.h>
#include <lxlist-inter.h>
#include <lxlist-types.h>
#include <nt.h>

int
_libx1f4i0_lxlist_b_keeping(void *context, void *output, void **input)
{
    int status;

    do {
	int (*copy)(void *, void *, void **, const void *,
		    const struct x1f4_nodelink_type *), type;
	struct cxbend_type *cxbend_data;
	struct dxlist_type *dxlist_data;
	struct lxlist_type *lxlist_data;
	struct lxtext_type *lxtext_data, *lxtext_link;
	unsigned miss;
	void *data, *side, *trap;

	cxbend_data = context;

	lxlist_data = cxbend_data->list;

	dxlist_data = I_LIST(input[0]);

	trap = input[1];

	type = ((struct x1f4_function_type *)
		((void **) input[-1])[X1f4_E4_RENDITION])->args[1];
	if (type == X1f4_E4_CASE) {
	    struct x1f4_dxcast_type *dxcast_data;

	    dxcast_data = I_USER(trap);
	    trap = &dxcast_data->data;
	    type = dxcast_data->type;
	}

	lxtext_link = lxlist_data->link_f.text;

	lxtext_data = lxtext_link;

	close_frame(miss, lxtext_data);

	if (miss) {
	    copy = lxtext_data->lxtype.copy;
	    if (copy) {
		status = copy
		    (lxtext_data->lxtype.context, NULL, &side, I_USER(trap),
		     lock_excase(dxlist_data));
		if (status) {
		    break;
		}
	    }
	} else {
	    copy = NULL;
	}

	if (0) {
	} else {
	    status = cxbend_data->push(dxlist_data->list, &data);
	    if (status) {
		status = _libx1f4i0_lxlist_stat_list(lxlist_data, 0, status);
		if (copy) {
		    lxtext_data->lxtype.free
			(lxtext_data->lxtype.context, side, NULL,
			 lock_excase(dxlist_data));
		}
	    } else {
		unsigned link;

		type_effect(data, type);

		link = miss ? lxtext_data - lxtext_link : ~0;

		link_effect(data, link);

		dxlist_data->size++;

		if (copy) {
		    l_USER(side, effect_data(data));
		} else {
		    copy_miss(effect_data(data), type, trap);
		}
	    }
	}
    } while (0);

    return status;
}

