/*
 * lxlist-k.s.c
 * Copyright (C) 2008-2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <copy.h>
#include <e4.h>
#include <l_list.h>
#include <lxcall.h>
#include <lxlist-drive.h>
#include <lxlist-inter.h>
#include <lxlist-types.h>

int
_libx1f4i0_lxlist_s_keeping(void *context, void *output, void **input)
{
    X1f4_E4_C_MODE mode;
    int status;
    struct cxbend_type *cxbend_data;
    struct dxlist_type *dxlist_data;
    unsigned size;
    void *data;

    dxlist_data = I_LIST(input[1]);

    cxbend_data = context;

    mode = I_MODE(input[2]);

    mode = -cxbend_data->bend;

    size = dxlist_data->size;
    if (mode < -(X1f4_E4_C_MODE) (int) size
	|| !(mode < (X1f4_E4_C_MODE) (int) size)) {
	l_MODE(mode, input[2]);
	l_MODE(0, output);
	if (1) {
	    status = 0;
	}
    } else {
	int pick;

	pick = mode;
	if (pick < 0) {
	    pick += size;
	}

	status = _libx1f4i0_peek_l4list(dxlist_data->list, pick, &data);
	if (status) {
	    status = _libx1f4i0_lxlist_stat_list(cxbend_data->list, 0, status);
	} else {
	    unsigned call, type;

	    type = effect_type(data);
	    call = *((struct x1f4_function_type *)
		 ((void **) input[-1])[X1f4_E4_RENDITION])->args;
	    if (type != call) {
		status = _libx1f4i0_lxlist_stat_type
		    (cxbend_data->list, mode, type, call);
	    } else {
		unsigned link;

		link = effect_link(data);

		l_MODE(1, output);

		do {
		    if (~link) {
			struct lxlist_type *lxlist_data;
			struct lxtext_type *lxtext_data;

			lxlist_data = cxbend_data->list;

			lxtext_data = lxlist_data->link_f.text;
			lxtext_data += link;
			if (lxtext_data->lxtype.lead
			    && lxtext_data->lxtype.slip) {
			    status = _libx1f4i0_lxcall_land_node
				(&lxlist_data->link_v, &lxlist_data->link_e,
				 &lxtext_data->lxtype, E_USER(data),
				 input[0]);

			    if (status) {
			    } else {
				l_MODE(mode, input[2]);
			    }

			    break;
			}

			if (lxtext_data->lxtype.copy
			    && lxtext_data->lxtype.push) {
			    status = _libx1f4i0_lxcall_side_node
				(&lxtext_data->lxtype, E_USER(data),
				 input[0]);

			    if (status) {
			    } else {
				l_MODE(mode, input[2]);
			    }

			    break;
			}
		    }

		    l_MODE(mode, input[2]);

		    copy_miss(*input, type, effect_data(data));
		} while (0);
	    }
	}
    }

    return status;
}
