/*
 * lxlist-l.m.c
 * Copyright (C) 2008-2011, 2013-2015, 2017, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <fd.h>
#include <l_list.h>
#include <lxlist-drive.h>
#include <lxlist-inter.h>
#include <lxlist-types.h>

int
_libx1f4i0_lxlist_m_logique(void *context, void *output, void **input)
{
    int status;
    struct dxlist_type *dxlist_data;

    dxlist_data = I_LIST(input[0]);
    if (0) {
    } else {
	X1f4_E4_C_MODE delete;
	unsigned size;

	delete = I_MODE(input[1]);

	size = dxlist_data->size;
	if (delete < -(X1f4_E4_C_MODE) (int) size
	    || !(delete < (X1f4_E4_C_MODE) (int) size)) {
	    status = _libx1f4i0_lxlist_stat_deck(context, size, delete);
	} else {
	    X1f4_E4_C_MODE insert;

	    insert = I_MODE(input[2]);

	    size++;

	    if (insert < -(X1f4_E4_C_MODE) (int) size
		|| !(insert < (X1f4_E4_C_MODE) (int) size)) {
		status = _libx1f4i0_lxlist_stat_deck(context, size, insert);
	    } else {
		if (insert < 0) {
		    insert += size;
		}

		size--;

		if (delete < 0) {
		    delete += size;
		}

		if (insert < delete || delete + 1 < insert) {
		    void *data, *list;

		    list = dxlist_data->list;

		    status = _libx1f4i0_push_l4list(list, insert, &data);
		    if (status) {
			status = _libx1f4i0_lxlist_stat_list
			    (context, 0, status);
		    } else {
			void *text;

			if (delete < insert) {
			} else {
			    delete++;
			}

			status = _libx1f4i0_peek_l4list(list, delete, &text);
			if (status) {
			    status = _libx1f4i0_lxlist_stat_list
				(context, 0, status);
			} else {
			    link_effect(data, effect_link(text));
			    type_effect(data, effect_type(text));

			    *(struct fxdata_type *) effect_data(data) =
				*(struct fxdata_type *) effect_data(text);

			    link_effect(text, ~0);

			    status = _libx1f4i0_miss_l4list(list, delete);
			    if (status) {
				status = _libx1f4i0_lxlist_stat_list
				    (context, 0, status);
			    } else {
			    }
			}
		    }
		} else {
		    status = 0;
		}

		if (status) {
		} else {
		    l_LIST(dxlist_data, output);
		}
	    }
	}
    }

    return status;
}
