/*
 * lxlist-l.t.c
 * Copyright (C) 2008-2011, 2013, 2014, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxlist-config.h>

#include <stddef.h>

#include <e4.h>
#include <fd.h>
#include <l_list.h>
#include <lxlist-drive.h>
#include <lxlist-inter.h>
#include <lxlist-types.h>

#define lxlist(list) \
    ((struct lxlist_type *) (list))

typedef X1f4_E4_C_USER x1f4_e4_c_user;

int
_libx1f4i0_lxlist_t_logique(void *context, void *output, void **input)
{
    X1f4_E4_C_MODE delete;
    int status;
    struct dxlist_type *dxlist_data;
    unsigned size;

    dxlist_data = I_LIST(input[0]);

    delete = I_MODE(input[1]);

    size = dxlist_data->size;
    if (delete < -(X1f4_E4_C_MODE) (int) size
	|| !(delete < (X1f4_E4_C_MODE) (int) size)) {
	status = _libx1f4i0_lxlist_stat_deck(context, size, delete);
    } else {
	X1f4_E4_C_MODE insert;
	struct dxlist_type *dxlist_text;
	unsigned mice;

	dxlist_text = I_LIST(input[2]);

	insert = I_MODE(input[3]);

	mice = dxlist_text->size;
	if (insert < -(X1f4_E4_C_MODE) (int) mice
	    || !(insert < (X1f4_E4_C_MODE) (int) mice)) {
	    status = _libx1f4i0_lxlist_stat_deck
		(context, mice, insert);
	} else {
	    void *data;

	    if (insert < 0) {
		insert += mice;
	    }

	    if (delete < 0) {
		delete += size;
	    }

	    status = _libx1f4i0_peek_l4list
		(dxlist_data->list, delete, &data);
	    if (status) {
		status = _libx1f4i0_lxlist_stat_list(context, 0, status);
	    } else {
		void *text;

		status = _libx1f4i0_peek_l4list
		    (dxlist_text->list, insert, &text);
		if (status) {
		    status =
			_libx1f4i0_lxlist_stat_list(context, 0, status);
		} else {
		    do {
			int trip;
			struct fxdata_type fxdata;
			unsigned link, sand;
			x1f4_e4_c_user Data, Text;

			link = effect_link(data);

			Data = E_USER(data);

			sand = effect_link(text);

			Text = I_USER(effect_data(text));

			trip = effect_type(data);
			type_effect(data, effect_type(text));
			type_effect(text, trip);
			trip = effect_link(data);
			link_effect(data, effect_link(text));
			link_effect(text, trip);

			fxdata = *(struct fxdata_type *) effect_data(data);
			*(struct fxdata_type *) effect_data(data) =
			    *(struct fxdata_type *) effect_data(text);
			*(struct fxdata_type *) effect_data(text) = fxdata;

			if (0) {
			} else {
			    int (*move)(void *, void *,
					const struct excase_type *,
					const struct excase_type *);
			    struct lxlist_type *lxlist_data;
			    struct lxtext_type *lxtext_data;

			    lxlist_data = context;

			    if (~link) {
				lxtext_data = (struct lxtext_type *)
				    lxlist_data->link_f.text + link;

				move = lxtext_data->lxtype.move;
				if (move) {
				    status = move
					(lxtext_data->lxtype.context, Data,
					 lock_excase(dxlist_data),
					 lock_excase(dxlist_text));
				    if (status) {
					break;
				    }
				}
			    }

			    if (~sand) {
				lxtext_data = (struct lxtext_type *)
				    lxlist_data->link_f.text + sand;

				move = lxtext_data->lxtype.move;
				if (move) {
				    status = move
					(lxtext_data->lxtype.context, Text,
					 lock_excase(dxlist_text),
					 lock_excase(dxlist_data));
				    if (status) {
					break;
				    }
				}
			    }
			}
		    } while (0);
		}
	    }
	}
    }

    return status;
}
