/*
 * lxlist-m.g-c.c
 * Copyright (C) 2008-2011, 2013, 2014, 2016-2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_list.h>
#include <lxlist-drive.h>
#include <lxlist-inter.h>
#include <lxlist-types.h>

int
_libx1f4i0_lxlist_i_class_m(void *context, void *output, void **input)
{
    X1f4_E4_C_MODE mode;
    int status;
    struct dxlist_type *dxlist_data;
    struct lxtext_type *lxtext_data;
    unsigned size;

    lxtext_data = context;

    dxlist_data = I_LIST(input[1]);

    mode = I_MODE(input[2]);

    size = dxlist_data->size;
    if (mode < -(X1f4_E4_C_MODE) (int) size
	|| !(mode < (X1f4_E4_C_MODE) (int) size)) {
	status = _libx1f4i0_lxlist_stat_deck(lxtext_data->text, size, mode);
    } else {
	void *data;

	if (mode < 0) {
	    mode += size;
	}

	status = _libx1f4i0_peek_l4list(dxlist_data->list, mode, &data);
	if (status) {
	    status = _libx1f4i0_lxlist_stat_list(lxtext_data->text, 0, status);
	} else {
	    X1f4_E4_C_MODE mode;
	    unsigned type;

	    type = effect_type(data);
	    switch (type) {
	    case X1f4_E4_BILL:
		mode = E_BILL(data);
		break;
	    case X1f4_E4_MODE:
		mode = E_MODE(data);
		break;
	    case X1f4_E4_REAL:
		mode = E_REAL(data);
		break;
	    default:
		mode = 0;
		status = _libx1f4i0_lxlist_stat_type
		    (lxtext_data->text, mode, type, X1f4_E4_MODE);
	    }

	    if (status) {
	    } else {
		l_MODE(mode, input[0]);
		l_MODE(mode, output);
	    }
	}
    }

    return status;
}

