/*
 * lxlong.h
 * Copyright (C) 2016, 2017, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxlong_H__
#define __LIBx1f4_lxlong_H__

#include <e4.h>
#include <lxlock.h>

#define _libx1f4i0_lxlong_bset_long	x1f4_bset_lxlong
#define _libx1f4i0_lxlong_near_long	x1f4_near_lxlong
#define _libx1f4i0_lxlong_tune_long	x1f4_tune_lxlong
#define _libx1f4i0_lxlong_uset_long	x1f4_uset_lxlong

#define ever_a				ever_d.east_1

#undef link_e
#undef link_m
#undef link_v
#undef link_w

#define link_e				ever_d.east_1.diff_e
#define link_m				ever_d.east_1.diff_m
#define link_v				ever_d.east_1.diff_v
#define link_w				ever_d.east_1.diff_w

#define link_f				ever_d.east_f
#define trap_e				ever_d.east_e

typedef struct lxlong_type {
    struct lxlock_type east_1;
    struct {
	void *data, *rate, *side, *text;
    } east_f;
    struct {
	const struct x1f4_eelookup_type *eelookup_data;
    } east_e;
} lxlong_type;

extern int _libx1f4i0_lxlong_bset_long
    (void *, const struct x1f4_operator_type **);
extern int _libx1f4i0_lxlong_stat_lead(void *, unsigned);
extern int _libx1f4i0_lxlong_near_long(void *);
extern int _libx1f4i0_lxlong_tune_long(void *);
extern int _libx1f4i0_lxlong_uset_long
    (void *, const struct x1f4_operator_type **);

#endif				/* __LIBx1f4_lxlong_H__ */
