/*
 * lxmile.h
 * Copyright (C) 2015, 2016, 2019, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxmile_H__
#define __LIBx1f4_lxmile_H__

#include <dt.h>
#include <ln.h>
#include <lxlong.h>
#include <nl.h>

#undef ever_a

#define ever_a				ever_n.nice_1.east_1

#undef link_e
#undef link_m
#undef link_v
#undef link_w

#define link_e				ever_n.nice_1.east_1.diff_e
#define link_m				ever_n.nice_1.east_1.diff_m
#define link_v				ever_n.nice_1.east_1.diff_v
#define link_w				ever_n.nice_1.east_1.diff_w

#undef link_f
#undef trap_e

#define link_f				ever_n.nice_1.east_f
#define trap_e				ever_n.nice_1.east_e

#define link_r				ever_n.nice_r

typedef struct lxfold_type {
    int (*copy)(void *, void *, void *, const void *,
		struct x1f4_caselink_type **), (*flat)(void *, void *),
	(*high)(void *, void *, struct x1f4_nodelink_type **),
	(*line)(void *, void *);
    struct x1f4_nodetype_type nodetype[1];
    unsigned trap;
    void *part, *text;
} lxfold_type;

typedef struct lxmile_type {
    struct lxlong_type nice_1;
    struct {
	int (*call)(void *, struct x1f4_nodelink_type *),
	    (*fine)(void *, struct x1f4_nodelink_type **,
		    struct x1f4_nodelink_type *),
	    (*miss)(void *, struct x1f4_nodelink_type **,
		    struct x1f4_nodelink_type *);
	void *text;
    } nice_r;
} lxmile_type;

extern int x1f4_copy_lxmile
    (void *, void *, void **, const void *,
     const struct x1f4_nodelink_type *);
extern int x1f4_copy_lxstar
    (void *, void *, void **, const void *,
     const struct x1f4_nodelink_type *);
extern int x1f4_dump_lxmile
    (void *, struct x1f4_nodelink_type *);
extern int x1f4_free_lxmile
    (void *, void *, struct x1f4_nodelink_type **,
     const struct x1f4_nodelink_type *);
extern int x1f4_hash_lxmile
    (void *, struct x1f4_nodelink_type **, struct x1f4_nodelink_type *);
extern int x1f4_lead_lxmile
    (void *, void **);
extern int x1f4_move_lxmile
    (void *, void *, const struct x1f4_nodelink_type *,
     const struct x1f4_nodelink_type *);
extern int x1f4_node_lxmile
    (void *, void **, void *, const struct x1f4_nodelink_type *);
extern int x1f4_pick_lxmile
    (void *, void *, struct x1f4_nodelink_type **,
     const struct x1f4_nodelink_type *);
extern int x1f4_push_lxmile
    (void *, void **, void *, const struct x1f4_nodelink_type *);
extern int x1f4_slip_lxmile
    (void *, void **);

#endif				/* __LIBx1f4_lxmile_H__ */
