/*
 * lxnear-d.m.c
 * Copyright (C) 2008-2011, 2013, 2016-2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <e4.h>
#include <lxnear-defs.h>
#include <lxnear-drive.h>
#include <lxnear-inter.h>
#include <lxnear-types.h>
#include <run.v.h>

int
_libx1f4i0_lxnear_m_derived(void *context, void *output, void **input)
{
    int status;
    struct lxtext_type *lxtext_data;

    lxtext_data = context;

    if (lxtext_data->bits & TYPED_TEXT) {
	X1f4_E4_C_USER user;

	user = I_USER(input[0]);
	lxtext_data->lead[1] = user;
	l_USER(user, output);
	input++;
    }

    do {
	X1f4_E4_C_BILL bill;
	X1f4_E4_C_MODE f;
	char line[8], *m;
	unsigned i;

	f = I_MODE(input[0]);
	if (f < 0) {
	    status = _libx1f4i0_lxnear_stat_lead(lxtext_data->text, f);
	    if (1) {
		break;
	    }
	}

	if (sizeof(X1f4_E4_C_MODE) < f) {
	    status = x1f4_vprint_run
		(lxtext_data->data, lxtext_data->push,
		 0, f - sizeof(X1f4_E4_C_MODE));
	    if (status) {
		break;
	    } else {
		f = sizeof(X1f4_E4_C_MODE);
	    }
	}

	bill = I_BILL(input[1]);

	m = line + sizeof(X1f4_E4_C_MODE);
	i = f;
	for (; i; i--) {
	    --m;
	    *m = bill;
	    bill >>= 8;
	}

	status = lxtext_data->push(lxtext_data->data, m, f);
    } while (0);

    return status;
}

