/*
 * lxnear-d.r.c
 * Copyright (C) 2008-2010, 2013, 2015, 2017, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <e4.h>
#include <lxnear-defs.h>
#include <lxnear-drive.h>
#include <lxnear-types.h>
#include <run.v.h>

int
_libx1f4i0_lxnear_r_derived(void *context, void *output, void **input)
{
    X1f4_E4_C_MODE f;
    int status;
    struct lxtext_type *lxtext_data;

    lxtext_data = context;

    if (lxtext_data->bits & TYPED_TEXT) {
	X1f4_E4_C_USER user;

	user = I_USER(input[0]);
	lxtext_data->lead[1] = user;
	l_USER(user, output);
	input++;
    }

    f = I_MODE(input[0]);

    if (f < 1) {
	status = 0;
    } else {
	status = x1f4_vprint_run
	    (lxtext_data->data, lxtext_data->push, I_MODE(input[1]), f);
    }

    return status;
}
