/*
 * lxnear-f.p.c
 * Copyright (C) 2008-2010, 2013, 2014, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxdata.h>
#include <lxnear-defs.h>
#include <lxnear-drive.h>
#include <lxnear-inter.h>
#include <lxnear-types.h>

int
_libx1f4i0_lxnear_p_forward(void *context, void *output, void **input)
{
    int status;
    struct lxtext_type *lxtext_data;

    lxtext_data = context;

    if (lxtext_data->bits & TYPED_TEXT) {
	X1f4_E4_C_USER user;

	user = I_USER(input[0]);
	lxtext_data->lead[1] = user;
	l_USER(user, output);
	input++;
    }

    do {
	X1f4_E4_C_MODE p, s;
	struct x1f4_dxdata_type *dxdata_data;
	unsigned size;

	dxdata_data = I_USER(input[0]);

	size = dxdata_data->length;
	size++;

	p = I_MODE(input[1]);

	if (p < -(X1f4_E4_C_MODE) (int) size
	    || !(p < (X1f4_E4_C_MODE) (int) size)) {
	    status = _libx1f4i0_lxnear_stat_time(lxtext_data->text, size, p);
	    if (1) {
		break;
	    }
	} else {
	}

	if (p < 0) {
	    p += size;
	}

	size--;

	s = I_MODE(input[2]);

	if (s < 0 || size < p + s) {
	    status = _libx1f4i0_lxnear_stat_norm(lxtext_data->text, s);
	    if (1) {
		break;
	    }
	} else {
	}

	status = lxtext_data->push
	    (lxtext_data->data, dxdata_data->string + p, s);
    } while (0);

    return status;
}
