/*
 * lxnear-i.p.c
 * Copyright (C) 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <cardinal.p-d.h>
#include <lcardinal.p-d.h>
#include <lxdate.h>

int
_libx1f4i0_lxnear_rule_time(char *line, unsigned *rule, void *dxtime)
{
    char *m, *n;
    struct x1f4_dxtime_type *dxtime_data;
    unsigned r, second_f;

    dxtime_data = dxtime;

    m = line;

    if (dxtime_data->second_l & 1 << 17) {
	*m++ = '-';
    }

    n = m + 20;
    x1f4_xprint_dlcardinal(&n, dxtime_data->second_a);
    r = m + 20 - n;
    memmove(m, n, r);

    m += r;

    second_f = dxtime_data->second_f;
    if (second_f) {
	n = m + 7;
	x1f4_xprint_dcardinal(&n, second_f);
	memset(m + 1, '0', n - m - 1);
	m[0] = '.';
	for (m += 6; *m == '0'; m--);
	m++;
    }

    *rule = m - line;

    return 0;
}
