/*
 * lxnear-l.w.c
 * Copyright (C) 2008-2010, 2013, 2017, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <e4.h>
#include <lintegral.n-fb.h>
#include <lintegral.v-fb.h>
#include <lintegral.v-wfb.h>
#include <lxnear-defs.h>
#include <lxnear-drive.h>
#include <lxnear-inter.h>
#include <lxnear-types.h>
#include <space.v.h>

int
_libx1f4i0_lxnear_w_logique(void *context, void *output, void **input)
{
    int status;
    struct lxtext_type *lxtext_data;

    lxtext_data = context;

    if (lxtext_data->bits & TYPED_TEXT) {
	X1f4_E4_C_USER user;

	user = I_USER(input[0]);
	lxtext_data->lead[1] = user;
	l_USER(user, output);
	input++;
    }

    do {
	X1f4_E4_C_MODE b, f, x, w;

	b = I_MODE(input[1]);

	f = I_MODE(input[2]);

	x = I_MODE(input[3]);

	w = I_MODE(input[0]);

	if (b < 0 || f < 0 || x < 2 || 36 < x) {
	    status = _libx1f4i0_lxnear_near_fill(lxtext_data, w);
	    if (1) {
		break;
	    }
	}

	if (w < 0) {
	    int (*push) (void *, const char *, unsigned);
	    void *data;

	    data = lxtext_data->data;
	    push = lxtext_data->push;

	    status = x1f4_vprint_fblintegral
		(data, push, 0, f, b, x, I_MODE(input[4]));
	    if (status) {
	    } else {
		unsigned v = 0;

		x1f4_nprint_fblintegral(&v, f, b, x, I_MODE(input[4]));
		w = -w;
		if (v < w) {
		    status = x1f4_vprint_space(data, push, w - v);
		}
	    }
	} else {
	    status = x1f4_vprint_wfblintegral
		(lxtext_data->data, lxtext_data->push, 0, w, f, b, x,
		 I_MODE(input[4]));
	}
    } while (0);

    return status;
}
