/*
 * lxrail-e.x.c
 * Copyright (C) 2008-2016, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <copy.h>
#include <e4.h>
#include <lxcast.h>
#include <lxlock.h>
#include <lxrail-types.h>

#define l_USER(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxrail_cast_data(void *context, void *output, unsigned type,
			    const void *data)
{
    int status;
    struct lxrail_type *lxrail_data;
    void *cast;

    lxrail_data = context;

    status = lxrail_data->link_v.link
	(lxrail_data->link_v.data, &cast, sizeof(struct x1f4_dxcast_type));
    if (status) {
	status = _libx1f4i0_lxlock_stat_link(lxrail_data);
    } else {
	struct x1f4_dxcast_type *dxcast_data;

	dxcast_data = cast;

	l_USER(cast, output);

	dxcast_data->call = 0;
	dxcast_data->type = type;

	copy_miss(&dxcast_data->data, type, data);
    }

    return status;
}
