/*
 * lxrail-e.y.c
 * Copyright (C) 2008-2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <copy.h>
#include <e4.h>
#include <exerrors.h>
#include <lxcall.h>
#include <lxcast.h>
#include <lxlock.h>
#include <lxlong.h>
#include <lxrail-types.h>

#define l_USER(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxrail_post_data(void *context, void *output, unsigned link,
			    unsigned type, const void *data)
{
    int status;
    struct lxrail_type *lxrail_data;

    lxrail_data = context;

    do {
	struct lxtext_type *lxtext_data;
	void *cast;

	if (~link) {
	    lxtext_data = lxrail_data->link_f.text;
	    lxtext_data += link;
	    if (lxtext_data->lxtype.lead) {
		if (lxtext_data->lxtype.code == X1f4_E4_TEXT) {
		    status = x1f4_cast_text
			(&lxrail_data->link_v, &lxrail_data->link_e,
			 (void *) data, output);
		    if (1) {
			break;
		    }
		} else {
		    status = x1f4_cast_node
			(&lxrail_data->link_v, &lxrail_data->link_e,
			 &lxtext_data->lxtype, type, data, output);
		    if (1) {
			break;
		    }
		}
	    }

	    if (lxtext_data->lxtype.copy && lxtext_data->lxtype.push) {
		if (1) {
		    status = _libx1f4i0_lxcall_draw_node
			(&lxrail_data->link_v, &lxrail_data->link_e,
			 &lxtext_data->lxtype, type, data, output);
		    if (1) {
			break;
		    }
		}
	    }
	}

#if 0
	if (X1f4_E4_LAST < type && type < X1f4_E4_CALL) {
	    status = _libx1f4i0_lxlong_stat_lead(lxrail_data, type);
	} else {
#endif				/* 0 */
	    status = lxrail_data->link_v.link
		(lxrail_data->link_v.data, &cast,
		 sizeof(struct x1f4_dxcast_type));
	    if (status) {
		status = _libx1f4i0_lxlock_stat_link(lxrail_data);
	    } else {
		struct x1f4_dxcast_type *dxcast_data;

		dxcast_data = cast;

		l_USER(cast, output);

		dxcast_data->call = 0;
		dxcast_data->type = type;

		copy_miss(&dxcast_data->data, type, data);
	    }
#if 0
	}
#endif				/* 0 */
    } while (0);

    return status;
}
