/*
 * lxrail-t.g.c
 * Copyright (C) 2008-2014, 2016-2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <lxcall.h>
#include <lxrail-drive.h>
#include <lxrail-inter.h>
#include <lxrail-types.h>

int
_libx1f4i0_lxrail_rank_text(struct lxrail_type *lxrail_data, int *rank,
			    void *data, void *output, void **input)
{
    int status, type;

    type = *rank;
    if (type != X1f4_E4_TEXT) {
	struct x1f4_composer_type *composer_data;

	composer_data = &lxrail_data->link_q;
	if (composer_data->link) {
	    const struct x1f4_linetext_type *linetext_data;

	    status = composer_data->link
		(composer_data->text, X1f4_E4_TEXT, type, &linetext_data);
	    if (status) {
	    } else {
		*rank = X1f4_E4_TEXT;

		status = linetext_data->function.function
		    ((void *) linetext_data->context, output, &data);
		if (status) {
		} else {
		    X1f4_E4_C_TEXT text;

		    text = I_TEXT(output);

		    status = _libx1f4i0_lxcall_swap_text
			(&lxrail_data->ever_a, *input, text, strlen(text) + 1);
		}
	    }
	} else {
	    status = -1;
	}
    } else {
	X1f4_E4_C_TEXT post;

	post = I_TEXT(data);

	status = _libx1f4i0_lxcall_swap_text
	    (&lxrail_data->ever_a, *input, post, strlen(post) + 1);
	if (status) {
	} else {
	    l_TEXT(I_TEXT(*input), output);
	}
    }

    return status;
}

