/*
 * lxrail-v.g.c
 * Copyright (C) 2008-2014, 2016-2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxcall.h>
#include <lxrail-drive.h>
#include <lxrail-inter.h>
#include <lxrail-types.h>

int
_libx1f4i0_lxrail_rank_node(struct lxrail_type *lxrail_data,
			    struct lxtext_type *lxtext_data, int name,
			    int *rank, void *data, void *output, void **input)
{
    int status, type;

    type = *rank;
    if (type != name) {
	struct x1f4_composer_type *composer_data;

	composer_data = &lxrail_data->link_q;
	if (composer_data->link) {
	    const struct x1f4_linetext_type *linetext_data;

	    status = composer_data->link
		(composer_data->text, name, type, &linetext_data);
	    if (status) {
	    } else {
		*rank = name;

		status = linetext_data->function.function
		    ((void *) linetext_data->context, output, &data);
		if (status) {
		} else {
		    status = _libx1f4i0_lxcall_rule_node
			(&lxrail_data->link_v, &lxrail_data->link_e,
			 &lxtext_data->lxtype, I_USER(output), input[0]);
		}
	    }
	} else {
	    status = -1;
	}
    } else {
	status = _libx1f4i0_lxcall_rule_node
	    (&lxrail_data->link_v, &lxrail_data->link_e,
	     &lxtext_data->lxtype, I_USER(data), input[0]);
	if (status) {
	} else {
	    l_USER(I_USER(*input), output);
	}
    }

    return status;
}

