/*
 * lxtime-a.x.c
 * Copyright (C) 2008, 2009, 2013, 2014, 2016, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxcall.h>
#include <lxdate-types.h>
#include <nt.h>

#define lxdate(date) \
    ((struct lxdate_type *) (date))

int
x1f4_push_lxtime(void *lxdate, void **copy, void *time,
		 const struct x1f4_nodelink_type *nodetype_data)
{
    int status;

    do {
	void *flat;

	flat = *copy;
	if (flat) {
	    status = x1f4_raft_node
		(&lxdate(lxdate)->link_v, &lxdate(lxdate)->link_e,
		 lxdate(lxdate)->link_t.datatype + 1, flat);
	    if (status) {
		break;
	    }
	} else {
	    status = 0;
	}

	*copy = (void *) time;
    } while (0);

    return status;
}
