/*
 * lxtrap-d.a.c
 * Copyright (C) 2019-2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <stdlib.h>
#include <string.h>

#include <e4.h>
#include <lxcast.h>
#include <lxtrap-drive.h>
#include <lxtrap-inter.h>
#include <lxtrap-types.h>

int
_libx1f4i0_lxtrap_a_derived(void *context, void *output, void **input)
{
    int status = 0;
    unsigned char *rule = NULL;

    do {
	int type;
	const int *fill;
	struct lxtrap_type *lxtrap_data;
	struct x1f4_dxcast_type *dxcast_data;
	struct x1f4_function_type *function_data;
	struct x1f4_linetext_type *linetext_data;
	unsigned fast, fold, i, j, late, mill, over, till;
	void **order, **used;

	lxtrap_data = context;

	dxcast_data = I_USER(input[0]);

	if (X1f4_E4_CALL < dxcast_data->type) {
	} else {
	    status = _libx1f4i0_lxtrap_stat_roll(lxtrap_data);
	    if (1) {
		break;
	    }
	}

	linetext_data = I_USER(&dxcast_data->data);
	if (linetext_data->function.function) {
	} else {
	    status = _libx1f4i0_lxtrap_stat_zero(lxtrap_data);
	    if (1) {
		break;
	    }
	}

	used = input[-1];

	function_data = used[X1f4_E4_RENDITION];

	fold = function_data->count - 1;

	if (fold) {
	} else {
	    l_USER(dxcast_data, output);

	    break;
	}

	if (255 < fold) {
	    status = _libx1f4i0_lxtrap_stat_over(lxtrap_data);
	    if (1) {
		break;
	    }
	}

	over = linetext_data->function.flags;

	till = linetext_data->function.count;

	late = 0;

	if (over & X1f4_E4_SIDE_LIST) {
	    mill = fold < till ? till : fold;
	} else {
	    mill = till;
	}

	rule = malloc(mill);
	if (rule) {
	} else {
	    status = _libx1f4i0_lxtrap_stat_link(lxtrap_data);
	    if (1) {
		break;
	    }
	}

	fill = function_data->args;

	order = input;

	fast = 0;

	memset(rule, 0, mill);

	fold++;
	for (j = 0, i = 1; i < fold; i++) {
	    X1f4_E4_C_MODE mode;

	    type = fill[i];
	    if (type != X1f4_E4_MODE) {
		status = _libx1f4i0_lxtrap_stat_iran(context, i);
		if (1) {
		    break;
		}
	    }

	    mode = I_MODE(order[i]);
	    if (mode < 0) {
		mode = 0;
	    } else {
	    }

	    if (mode) {
		if (mill < j + mode || !(i + mode < fold)) {
		    status = _libx1f4i0_lxtrap_stat_sell(context, mode);
		    if (1) {
			break;
		    }
		}

		late -= mode;
		for (; mode; mode--, j++) {
		    i++;
		    rule[j] = i;
		}

		fast = j;
	    } else {
		j++;

		/*
		 * this doesn't (yet) apply anything.  maybe future versions
		 * will do different.  and will need to test for range
		 * boundaries.
		 */
	    }
	}
	if (status) {
	    break;
	}

	if (till < mill) {
	    if (fast < till) {
		fast = till;
	    } else {
	    }
	    late += fast;
	    fold = fast - late;
	} else {
	    fast = mill;
	    late += mill;
	    fold = mill - late;
	}

	if (fold) {
	} else {
	    l_USER(dxcast_data, output);

	    break;
	}

	status = _libx1f4i0_lxtrap_half_into
	    (context, output, input, linetext_data, function_data, fold, late,
	     fast, &rule);
    } while (0);

    if (rule) {
	free(rule);
    }

    return status;
}

