/*
 * lxvery-a.b.c
 * Copyright (C) 2008-2016, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <d_fset.h>
#include <lxfset.h>
#include <lxvery-inter.h>
#include <lxvery-types.h>

#define dxvery(line) \
    ((struct dxvery_type *) (line))

int
x1f4_copy_lxvery(void *subtext, void *bppp, void **copy,
		 const void *line, const struct excase_type *excase_data)
{
    int status;
    struct lxvery_type *lxvery_data;
    unsigned call;
    void *dxvery;

    lxvery_data = subtext;

    _libx1f4i0_call_lxfset(&call);

    status = lxvery_data->link_m.link
	(lxvery_data->link_m.data, &dxvery,
	 __struct_dxvery_type_alloc_size__ + call);
    if (status) {
	status = _libx1f4i0_lxvery_stat_link(lxvery_data);
    } else {
	if (1) {
	    if (1) {
		dxvery(dxvery)->call = 1;

		if (0) {
		} else {
		    status = _libx1f4i0_lxvery_fast_line(subtext, dxvery);
		    if (status) {
		    } else {
			status = _libx1f4i0_line_lxfset
			    (dxvery(dxvery)->dash, dxvery(line)->dash,
			     _libx1f4i0_lxvery_copy_link,
			     _libx1f4i0_lxvery_free_link, NULL);
			if (status) {
			    status = _libx1f4i0_lxvery_stat_line
				(lxvery_data, 0, status);

			    _libx1f4i0_flat_lxfset
				(((struct dxvery_type *) dxvery)->dash);
			}
		    }
		    if (status) {
		    } else {
			dxvery(dxvery)->size = dxvery(line)->size;

			*copy = dxvery;

			dxvery = NULL;
		    }
		}
	    }
	}

	if (dxvery) {
	    lxvery_data->link_m.free(lxvery_data->link_m.data, dxvery);
	}
    }

    return status;
}
