/*
 * lxvery-a.l.c
 * Copyright (C) 2008-2015, 2018, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <e4.h>
#include <lxvery-inter.h>
#include <lxvery-types.h>

#define dxvery(line) \
    ((struct dxvery_type *) (line))

int
_libx1f4i0_lxvery_null_line(void *lxvery, struct excase_type **excase,
			    void *dxvery)
{
    int status = 0;
    unsigned size;

    size = dxvery(dxvery)->size;
    if (size) {
	int excess;

	dxvery(dxvery)->size = 0;

	excess = _libx1f4i0_high_lxfset(dxvery(dxvery)->dash);
	if (excess) {
	    status = _libx1f4i0_lxvery_stat_line(lxvery, status, excess);
	}
    }

    return status;
}
