/*
 * lxvery-f.n.c
 * Copyright (C) 2008-2011, 2013-2015, 2018, 2019, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <lxcall.h>
#include <lxvery-drive.h>
#include <lxvery-inter.h>
#include <lxvery-types.h>

#define l_LINE(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxvery_n_forward(void *context, void *output, void **input)
{
    int status;
    struct dxvery_type *dxvery_data;
    struct lxvery_type *lxvery_data;

    dxvery_data = I_LINE(input[0]);

    lxvery_data = context;

    if (dxvery_data->call == 1) {
	if (dxvery_data->size) {
	    status = _libx1f4i0_lxvery_null_line(context, NULL, dxvery_data);
	} else {
	    status = 0;
	}
    } else {
	status = _libx1f4i0_lxvery_line_line(lxvery_data, input[0]);
	if (status) {
	} else {
	    status = x1f4_raft_node
		(&lxvery_data->link_v, &lxvery_data->link_e,
		 lxvery_data->link_t.datatype, dxvery_data);
	}
    }

    return status;
}
