/*
 * lxvery-i.j.c
 * Copyright (C) 2011-2018, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <lxcall.h>
#include <lxcast.h>
#include <lxvery-defs.h>
#include <lxvery-drive.h>
#include <lxvery-inter.h>
#include <lxvery-types.h>

#define dxvery(list) \
    ((struct dxvery_type *) (list))
#define lxvery(list) \
    ((struct lxvery_type *) (list))

extern const void *const x1f4_a1_walk_link;

static int rule_dash(void *, void *);

static int
rule_dash(void *line, void *data)
{
    struct fydata_type **fydata;

    fydata = line;

    l_MODE(*(X1f4_E4_C_MODE *) data - VERY_BASE, *fydata);

    (*fydata)++;

    return 0;
}


int
_libx1f4i0_lxvery_very_list(void *lxvery, void *output, void **input,
			    void **track,
			    struct x1f4_linetext_type *linetext_data,
			    unsigned count,
			    const struct x1f4_function_type *function_text,
			    int lead, int jack, void *dxvery)
{
    int status;
    void *beta;

    status = lxvery(lxvery)->link_v.link
	(lxvery(lxvery)->link_v.data, &beta,
	 count * sizeof(struct fydata_type));
    if (status) {
	status = _libx1f4i0_lxvery_stat_link(lxvery);
    } else {
	void *line;

	line = beta;
	status = _libx1f4i0_lime_lxfset
	    (dxvery(dxvery)->dash, &line, rule_dash);
	if (status) {
	} else {
	    if (output == x1f4_a1_walk_link) {
		status = _libx1f4i0_lxmode_draw_call
		    (lxvery, output, input, linetext_data, count,
		     function_text, lead, jack, X1f4_E4_MODE, beta);
	    } else {
		status = _libx1f4i0_lxmode_jack_call
		    (lxvery, output, input, linetext_data, count,
		     function_text, lead, jack, X1f4_E4_MODE, beta);
	    }
	}
    }

    return status;
}
