/*
 * lxvery-l.k.c
 * Copyright (C) 2008-2013, 2015, 2018, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxvery-config.h>

#include <d_fset.h>
#include <e4.h>
#include <lxvery-drive.h>
#include <lxvery-types.h>

#define dxvery(line) \
    ((struct dxvery_type *) (line))

int
_libx1f4i0_lxvery_k_logique(void *context, void *output, void **input)
{
#if __VERY_PSET__
    l_MODE(x1f4_find_bqpset
	   (dxvery(I_LINE(input[0]))->dash,
	    (void *) (integral_q)
	    (I_MODE(input[1]) + (~(X1f4_E4_C_BILL) 0 >> 1))), output);
#else
    X1f4_E4_C_MODE very;
    void *data;

    very = I_MODE(input[1]);

    l_MODE(x1f4_find_lxfset
	   (dxvery(I_LINE(input[0]))->dash, &very, &data), output);
#endif				/* __VERY_PSET__ */

    return 0;
}
