/*
 * lxvery-p.s.c
 * Copyright (C) 2008-2010, 2013, 2014, 2016, 2019, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <lxcall.h>
#include <lxvery-drive.h>
#include <lxvery-inter.h>
#include <lxvery-types.h>

#define lock_exdata(data) \
    (data)

int
_libx1f4i0_lxvery_s_pending(void *context, void *output, void **input)
{
    int status;
    struct dxvery_type *dxvery_flat, *dxvery_text;
    struct lxvery_type *lxvery_data;

    dxvery_flat = I_LINE(input[0]);
    dxvery_text = I_LINE(input[1]);

    lxvery_data = context;

    do {
	if (dxvery_flat) {
	    status = x1f4_raft_node
		(&lxvery_data->link_v, &lxvery_data->link_e,
		 lxvery_data->link_t.datatype, dxvery_flat);
	    if (status) {
		break;
	    }
	} else {
	    status = 0;
	}

	lock_exdata(dxvery_text)->call++;

	l_LINE(dxvery_text, input[0]);
	l_LINE(dxvery_text, output);
    } while (0);

    return status;
}
