/*
 * lxxsxx-1.e.c
 * Copyright (C) 2008-2012, 2014, 2016, 2022, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <sys/types.h>
#include <sys/wait.h>

#include <e4.h>
#include <lxport-drive.h>
#include <lxport-types.h>

#define xsport(port) \
    ((struct xsport_type *) (port))

int
_libx1f4i0_lxport_e_1xshell(void *context, void *output, void **input)
{
    int effect;

    effect = xsport(I_PORT(input[0]))->waitlink_data->status;
    if (WIFEXITED(effect)) {
	l_MODE(1, output);
	l_MODE(WEXITSTATUS(effect), input[1]);
    } else {
	l_MODE(0, output);
	if (WIFSIGNALED(effect)) {
	    l_MODE(WTERMSIG(effect), input[1]);
	}
    }

    return 0;
}
