/*
 * lxxsxx-2.w.c
 * Copyright (C) 2008-2011, 2013, 2014, 2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxport-drive.h>
#include <lxport-inter.h>
#include <lxport-types.h>

int
_libx1f4i0_lxport_w_2xshell(void *context, void *output, void **input)
{
    int status;
    struct waitlink_type *waitlink_data;
    struct xsport_type *xsport_data;

    xsport_data = I_PORT(input[0]);

    waitlink_data = xsport_data->waitlink_data;

    do {
	if (waitlink_data->port ^ -1) {
	    X1f4_E4_C_MODE second_a, second_f;

	    second_a = I_MODE(input[1]);
	    second_f = I_MODE(input[2]);

	    second_a += second_f / 1000000;
	    second_f %= 1000000;
	    if (second_f < 0) {
		second_a--;
		second_f += 1000000;
	    }

	    if (second_a < 0) {
		second_a = second_f = 0;
	    }

	    status = _libx1f4i0_lxport_rend_port
		(context, waitlink_data, second_a, second_f);
	    if (status) {
		break;
	    }
	} else {
	    status = 0;
	}

	l_XSXX(xsport_data, output);
    } while (0);

    return status;
}
