/*
 * progress.h
 * Copyright (C) 2017-2019, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_progress_H__
#define __LIBx1f4_progress_H__

/*
 * flag definitions
 */
#define X1f4_PROGRESS_BACKWARD		(1 << 0)
#define X1f4_PROGRESS_EQCLAUSE		(1 << 1)
#define X1f4_PROGRESS_GECLAUSE		(1 << 2)
#define X1f4_PROGRESS_GTCLAUSE		(1 << 3)
#define X1f4_PROGRESS_LECLAUSE		(1 << 4)
#define X1f4_PROGRESS_LTCLAUSE		(1 << 5)

#define X1f4_PROGRESS_POSITION \
    (X1f4_PROGRESS_EQCLAUSE | X1f4_PROGRESS_GECLAUSE | X1f4_PROGRESS_GTCLAUSE \
     | X1f4_PROGRESS_LECLAUSE | X1f4_PROGRESS_LTCLAUSE)

typedef struct x1f4_fragment_type {
    const char *text;
    unsigned fit1, fit2, pass, size;
} x1f4_fragment_type;

typedef struct x1f4_position_type {
    struct x1f4_fragment_type in_clause;
    unsigned bits;
} x1f4_position_type;

typedef struct x1f4_progress_type {
    struct x1f4_fragment_type do_clause, if_clause;
    int arg1, arg2, type;
    unsigned bits, count;
    const struct x1f4_position_type *position_data;
} x1f4_progress_type;

#endif				/* __LIBx1f4_progress_H__ */
