/*
 * qscb.r.c
 * Copyright (C) 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <qscc-names.h>
#include <qscc-types.h>

int
_libx1f4l2_late_qsrate(void *node, unsigned rate, unsigned lock,
		       unsigned *size)
{
    struct fpnode_type *fpnode_data;
    unsigned call = 0, line;

    line = 1 << lock >> 1;

    fpnode_data = node;

    while (rate) {
	unsigned half;

	fpnode_data = fpnode_data->star;

	half = line;
	while (half) {
	    fpnode_data += half;
	    call += fpnode_data->call;
	    half >>= 1;
	}

	rate--;

	if (fpnode_data->node) {
	} else {
	    break;
	}
    }

    call += fpnode_data->node;

    *size = call;

    return 0;
}
