/*
 * sfas.3.c
 * Copyright (C) 2009-2012, 2018, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <string.h>

#include <sfas-inter.h>
#include <sfas-names.h>
#include <sfas-patch.h>
#include <sfas-types.h>

#define back(miss)			((const char *) (miss))
#define fast(miss)			((const byte *) (miss))

#define sfnote(sfnote)			((struct sfnote_type *) (sfnote))

int
x1f4_pass_sfnote(void *sfnote, const char *name)
{
    int status;
    struct fpnode_type *fpnode_data, *fpnode_slip = NULL;

    fpnode_data = sfnote(sfnote)->link_a.fpdeck.fpnode_data;
    if (fpnode_data) {
	const char *lead;

	lead = name;

	do {
	    byte *slip;
	    int e;
	    unsigned length;

	    e = prefix(fpnode_data);
	    if (e) {
		if (e ^ *fast(name)) {
		    status = 0;
		    if (1) {
			break;
		    }
		} else {
		    name++;
		    abstract_node(fpnode_data, slip, length);
		}
	    } else {
		length = 0;
		slip = NULL;
	    }

	    while (1) {
		int c;

		c = *fast(name);
		if (c) {
		    name++;
		    if (length) {
			if (c == *slip) {
			    length--;
			    slip++;
			} else {
			    status = 0;
			    if (1) {
				break;
			    }
			}
		    } else {
			unsigned bits;

			bits = fpnode_data->bits;
			if (Extant(bits)) {
			    fpnode_slip = fpnode_data;
			    dispatch_slip(fpnode_data, bits, c);
			} else {
			    status = 0;
			    if (1) {
				break;
			    }
			}
		    }
		} else {
		    if (extant(fpnode_data)) {
			if (length) {
			    status = 0;
			} else {
			    fpnode_slip = fpnode_data;
			    fpnode_data =
				(struct fpnode_type *) fpnode_data->data;
			    if (prefix(fpnode_data)) {
				if (1) {
				    status = 0;
				}
			    } else {
				status = _libx1f4l2_blue_sfnote
				    (sfnote, fpnode_slip, fpnode_data);
			    }
			}
		    } else {
			if (length) {
			    status = 0;
			} else {
			    if (fpnode_slip) {
				status = _libx1f4l2_blue_sfnote
				    (sfnote, fpnode_slip, fpnode_data);
			    } else {
				status = _libx1f4l2_fail_sfnote
				    (sfnote, fpnode_data);
			    }
			}
		    }

		    break;
		}
	    }
	} while (0);
    } else {
	status = 0;
    }

    return status;
}
