/*
 * srand.c
 * Copyright (C) 2007-2014, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <stddef.h>
#include <stdlib.h>
#include <time.h>

#if defined HAVE_GETTIMEOFDAY
# include <sys/time.h>
#endif				/* HAVE_GETTIMEOFDAY */

#if defined HAVE_GETTIMEOFDAY
# define SRAND_INIT() \
    {									      \
	struct timeval time;						      \
									      \
	gettimeofday(&time, NULL);					      \
	srand(time.tv_usec);						      \
    }
#else
# define SRAND_INIT() \
    {									      \
	srand(time(NULL));						      \
    }
#endif				/* HAVE_GETTIMEOFDAY */

#if 1
# define SRAND_LEAD(___l) \
    {									      \
	srand((___l));							      \
    }
#endif				/* 1 */

int _libx1f4i0_rand_init = 1;

int
_libx1f4i0_lead_rand(int seed)
{
    _libx1f4i0_rand_init = 0;
    SRAND_LEAD(seed);

    return 0;
}


int
_libx1f4i0_seed_rand(void)
{
    if (_libx1f4i0_rand_init) {
	_libx1f4i0_rand_init = 0;
	SRAND_INIT();
    }

    return 0;
}
